import { CancelToken, IClassOf } from "@web-atoms/core/dist/core/types";
import XNode from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
export interface IFetchEvent {
    search?: string;
    value?: any;
    cancel?: CancelToken;
}
export default class AutoCompleteBox extends AtomControl {
    static itemTemplate: (attributes: Partial<unknown>, ...nodes: XNode[]) => XNode;
    itemTemplate: IClassOf<AtomControl>;
    selectedItem: any;
    previousItem: any;
    value: any;
    /**
     * Label is displayed in place holder
     * @type {*}
     * @memberof AutoCompleteBox
     */
    label: any;
    items: any[];
    itemsSource: (fetchEvent: IFetchEvent) => Promise<any[]> | any[];
    valueFunc: ((item: any) => any);
    itemHostTemplate: IClassOf<AtomControl>;
    searchText: string;
    isPopupOpen: boolean;
    private lastSearchText;
    private lastValue;
    private cancelToken;
    private windowViewModel;
    private created;
    private isUpdating;
    onPropertyChanged(name: string): void;
    onUpdateUI(): void;
    hasProperty(name: string): boolean;
    protected onSearchTextChanged(force?: boolean): void;
    protected runAsync(fx: () => Promise<void>): void;
    protected preCreate(): void;
    protected create(): void;
    protected onKey(e: KeyboardEvent): void;
    protected moveSelection(n: number): void;
    protected openPopup(force?: boolean): Promise<void>;
}
//# sourceMappingURL=AutoCompleteBox.d.ts.map