import XNode from "@web-atoms/core/dist/core/XNode";
import AtomRepeater, { Match } from "./AtomRepeater";
import type { IChip } from "./Chip";
export { default as Chip } from "./Chip";
import "./styles/chips.global.css";
import "./styles/item-suggestion.global.css";
export declare function Suggestion({ icon, label, header, deleteIcon, ...a }: IChip, ...nodes: XNode[]): any;
export default class AtomChips<T = any> extends AtomRepeater<T> {
    /**
     * Fired when user chooses an item from suggestions displayed,
     * You can call preventDefault() to prevent suggestion to be
     * added in the chips. You can expect detail and you can
     * change the item by changing detail or by assigning to new
     * object
     */
    "event-suggestion-chosen"?: (e: CustomEvent<T>) => any;
    /**
     * Fired just before suggestions are about to be displayed
     */
    "event-suggestions-requested"?: (ce: CustomEvent<T[]>) => any;
    /**
     * Fired when user tries to remove the chip, you can call
     * preventDefault() to prevent chip from being removed.
     */
    "event-remove-chip"?: (e: CustomEvent<T>) => any;
    suggestions: T[];
    search: string;
    prompt: string;
    suggestionPrompt: string;
    autofocus: any;
    /**
     * boolean or string, if it is a string it should be the name of property. default is `$deleted` if set to true
     */
    softDeleteProperty: string;
    labelPath: (item: T) => string;
    match: Match<any>;
    suggestionRenderer: (item: T, index: number, repeater: AtomRepeater) => XNode;
    suggestionFilter: (item: any) => boolean;
    itemToChip: (item: any, search: any) => any;
    preventDuplicates: boolean;
    focused: boolean;
    anchorItem: any;
    onKeyPressedItemToChip: (key: string, search: string) => any;
    onBlurItemToChip: (search: string) => any;
    get searchType(): string;
    set searchType(v: string);
    get enterKeyHint(): string;
    set enterKeyHint(v: string);
    protected searchInput: HTMLInputElement;
    private anchorIndex;
    private popupCancelToken;
    private suggestionsWatcher;
    private focusTimeout;
    onPropertyChanged(name: string): void;
    protected preCreate(): void;
    protected setFocus(hasFocus: any): void;
    protected updatePopup(): Promise<void>;
    protected addItem(selectedItem: any): void;
    protected undoRemoveItem(item: any): void;
    protected removeItem(item: any): void;
    protected onKey(e: KeyboardEvent): void;
}
//# sourceMappingURL=AtomChips.d.ts.map