System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "./AtomRepeater", "./styles/suggestion.global.css"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, Bind, BindableProperty, XNode, AtomRepeater, askSuggestion, askSuggestionPopup, AtomSuggestions;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
      askSuggestion = _AtomRepeater.askSuggestion;
      askSuggestionPopup = _AtomRepeater.askSuggestionPopup;
    }, function (_stylesSuggestionGlobalCss) {}],
    execute: function () {
      _export("default", AtomSuggestions = class AtomSuggestions extends AtomRepeater {
        constructor() {
          super(...arguments);
          this.isPopupOpen = false;
        }
        onPropertyChanged(name) {
          var _a;
          super.onPropertyChanged(name);
          switch (name) {
            case "selectedItems":
              (_a = this.selectedItemsWatcher) === null || _a === void 0 ? void 0 : _a.dispose();
              const si = this.selectedItems;
              if (!si) {
                this.selectedItemsWatcher = null;
                return;
              }
              const d = si.watch(() => this.version++);
              this.selectedItemsWatcher = this.registerDisposable(d);
              this.version++;
              break;
            case "version":
            case "search":
            case "items":
              this.updateVisibilityFilter();
              break;
          }
        }
        updateVisibilityFilter() {
          var _a, _b;
          const vp = (_a = this.valuePath) !== null && _a !== void 0 ? _a : item => item;
          const selectedItems = (_b = this.selectedItems) !== null && _b !== void 0 ? _b : [];
          const selectedValues = selectedItems.map(vp);
          const search = this.match(this.search);
          this.visibilityFilter = item => {
            const v = vp(item);
            if (!search(item)) {
              return false;
            }
            return selectedValues.length === 0 || selectedValues.indexOf(v) === -1;
          };
        }
        create() {
          this.version = 1;
          this.search = "";
          this.render(XNode.create("div", {
            "data-suggestions": "suggestions",
            eventItemClick: e => this.addItem(e.detail)
          }, XNode.create("span", {
            class: "header",
            text: Bind.oneWay(() => this.title)
          }), XNode.create("div", {
            class: "items"
          }), XNode.create("div", {
            class: "more",
            eventClick: Bind.event(() => this.more())
          }, "More")));
          this.itemsPresenter = this.element.children[1];
          this.updateItems();
        }
        more() {
          return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c;
            if (this.isPopupOpen) {
              return;
            }
            this.isPopupOpen = true;
            try {
              const vf = (_a = this.visibilityFilter) !== null && _a !== void 0 ? _a : item => true;
              if (!this.popupSuggestions) {
                const selected = yield askSuggestion(this.items.filter(vf), (_b = this.suggestionRenderer) !== null && _b !== void 0 ? _b : this.itemRenderer, text => this.match(text), {
                  title: this.title
                });
                this.addItem(selected);
                return;
              }
              const selectedItem = yield askSuggestionPopup(this, this.items, (_c = this.suggestionRenderer) !== null && _c !== void 0 ? _c : this.itemRenderer, text => this.match(text), this.selectedItem);
              this.addItem(selectedItem);
            } finally {
              this.isPopupOpen = false;
            }
          });
        }
        addItem(selectedItem) {
          var _a, _b;
          const ce = new CustomEvent("itemSelected", {
            bubbles: true,
            detail: selectedItem,
            cancelable: true
          });
          this.element.dispatchEvent(ce);
          if (!ce.defaultPrevented) {
            const selectedItem = ce.detail;
            const vp = (_a = this.valuePath) !== null && _a !== void 0 ? _a : i => i;
            const value = vp(selectedItem);
            if (this.selectedItems) {
              for (const iterator of this.selectedItems) {
                if (vp(iterator) == value) {
                  return;
                }
              }
            }
            (_b = this.selectedItems) === null || _b === void 0 ? void 0 : _b.add(selectedItem);
          }
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomSuggestions.prototype, "valuePath", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomSuggestions.prototype, "title", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomSuggestions.prototype, "match", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomSuggestions.prototype, "search", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], AtomSuggestions.prototype, "version", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], AtomSuggestions.prototype, "suggestionRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Boolean)], AtomSuggestions.prototype, "popupSuggestions", void 0);
    }
  };
});
//# sourceMappingURL=AtomSuggestions.js.map