System.register(["tslib", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "./ButtonBar.global.css"], function (_export, _context) {
  "use strict";

  var __rest, XNode, AtomControl, nid, labelPathSetter, valuePathSetter, namePathSetter, itemRendererSetter, refreshItems, itemsSetter, changeTracker;
  function ButtonBar(_a) {
    var {
        items,
        labelPath,
        valuePath,
        itemRenderer = x => {
          var _a;
          return XNode.create("div", {
            text: (_a = x.label) !== null && _a !== void 0 ? _a : x
          });
        },
        value,
        name = `button-bar-${nid++}`
      } = _a,
      a = __rest(_a, ["items", "labelPath", "valuePath", "itemRenderer", "value", "name"]);
    a[labelPathSetter.property] = labelPath;
    a[valuePathSetter.property] = valuePath;
    a[itemsSetter.property] = items;
    a[itemRendererSetter.property] = itemRenderer;
    a[namePathSetter.property] = name;
    a["event-change"] = changeTracker;
    return XNode.create("button-bar", Object.assign({}, a), XNode.create("input", {
      class: "hidden",
      value: value
    }));
  }
  _export("default", ButtonBar);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_ButtonBarGlobalCss) {}],
    execute: function () {
      nid = 1;
      labelPathSetter = AtomControl.registerProperty("data-button-bar-items", "label", (ctrl, element, value) => {
        element["labelPath"] = value;
      });
      valuePathSetter = AtomControl.registerProperty("data-button-bar-items", "value", (ctrl, element, value) => {
        element["valuePath"] = value;
      });
      namePathSetter = AtomControl.registerProperty("data-button-bar-items", "name", (ctrl, element, value) => {
        element["namePath"] = value;
      });
      itemRendererSetter = AtomControl.registerProperty("data-button-bar-items", "renderer", (ctrl, element, value) => {
        element["itemRenderer"] = value;
      });
      refreshItems = (element, items) => {
        var _a, _b, _c;
        items !== null && items !== void 0 ? items : items = element["items"];
        const lp = (_a = element["labelPath"]) !== null && _a !== void 0 ? _a : item => {
          var _a;
          return (_a = item === null || item === void 0 ? void 0 : item.label) !== null && _a !== void 0 ? _a : item;
        };
        const vp = (_b = element["valuePath"]) !== null && _b !== void 0 ? _b : item => {
          var _a;
          return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item;
        };
        const ir = (_c = element["itemRenderer"]) !== null && _c !== void 0 ? _c : item => XNode.create("div", {
          text: lp(item)
        });
        const name = element["namePath"];
        let i = 0;
        const all = Array.from(element.querySelectorAll(`label`));
        for (const element of all) {
          element.remove();
        }
        const control = AtomControl.from(element);
        const hidden = element.querySelector(`input.hidden`);
        const cv = hidden.value;
        if (items === null || items === void 0 ? void 0 : items.length) {
          for (const iterator of items) {
            const item = document.createElement("label");
            const labelName = name + i;
            const value = vp(iterator);
            let checked = false;
            if (cv !== void 0) {
              if (cv == value) {
                checked = true;
              }
            }
            item.setAttribute("for", labelName);
            element.appendChild(item);
            control.render(XNode.create("div", null, " ", XNode.create("input", {
              id: labelName,
              type: "radio",
              name: name,
              value: value,
              checked: checked
            }), " ", ir(iterator)), item, control);
            i++;
          }
        }
      };
      itemsSetter = AtomControl.registerProperty("data-items", "value", (ctrl, element, value) => {
        element["items"] = value;
        ctrl.runAfterInit(() => setTimeout(refreshItems, 1, element, value));
      });
      changeTracker = e => {
        if (e.detail) {
          return;
        }
        const target = e.currentTarget;
        const hidden = target.querySelector(`input.hidden`);
        const buttons = target.querySelectorAll(`input[type="radio"]`);
        for (let index = 0; index < buttons.length; index++) {
          const element = buttons[index];
          if (element.checked) {
            hidden.value = element.value;
            hidden.dispatchEvent(new CustomEvent("input", {
              detail: element.value,
              bubbles: true
            }));
            break;
          }
        }
      };
    }
  };
});
//# sourceMappingURL=ButtonBar.js.map