System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/XNode", "./AtomRepeater", "./Editable", "./TableRepeater", "./styles/data-grid.global.css"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, BindableProperty, CancelToken, XNode, SelectorCheckBox, EditableInput, getPropertyInfo, TableRepeater, DataGrid, cellEventName, headerEventName, footerEventName, fromHyphenToCamel, toEventName, getCellEventName, getHeaderEventName, getFooterEventName, SelectAllColumn;
  function InputColumn({
    type = "text",
    header,
    propertyPath
  }) {
    const property = getPropertyInfo(propertyPath);
    return {
      header,
      cellRenderer: item => XNode.create(EditableInput, {
        propertyPath: propertyPath,
        value: property.getter(item),
        type: type
      })
    };
  }
  _export({
    InputColumn: InputColumn,
    default: void 0
  });
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      SelectorCheckBox = _AtomRepeater.SelectorCheckBox;
    }, function (_Editable) {
      EditableInput = _Editable.EditableInput;
      getPropertyInfo = _Editable.getPropertyInfo;
    }, function (_TableRepeater) {
      TableRepeater = _TableRepeater.default;
    }, function (_stylesDataGridGlobalCss) {}],
    execute: function () {
      cellEventName = Symbol("cell-event-name");
      headerEventName = Symbol("header-event-name");
      footerEventName = Symbol("footer-event-name");
      fromHyphenToCamel = input => input.replace(/-([a-z])/ig, g => g[1].toUpperCase());
      toEventName = name => {
        const r = fromHyphenToCamel(name.replace(/\s+/, "-"));
        return r[0].toLowerCase() + r.substring(1);
      };
      getCellEventName = d => {
        var _a;
        let name = d[cellEventName];
        if (name !== void 0) {
          return name;
        }
        name = toEventName((_a = d.cellClickEvent) !== null && _a !== void 0 ? _a : `cell-${d.header}-click`);
        d[cellEventName] = name;
        return name;
      };
      getHeaderEventName = d => {
        var _a;
        let name = d[headerEventName];
        if (name !== void 0) {
          return name;
        }
        name = toEventName((_a = d.headerClickEvent) !== null && _a !== void 0 ? _a : `header-${d.header}-click`);
        d[headerEventName] = name;
        return name;
      };
      getFooterEventName = d => {
        var _a;
        let name = d[footerEventName];
        if (name !== void 0) {
          return name;
        }
        name = toEventName((_a = d.footerClickEvent) !== null && _a !== void 0 ? _a : `footer-${d.header}-click`);
        d[footerEventName] = name;
        return name;
      };
      _export("SelectAllColumn", SelectAllColumn = {
        header: "Select All",
        headerRenderer: () => XNode.create("th", null, XNode.create("input", {
          type: "checkbox",
          checked: Bind.oneTime(x => x.allSelected)
        })),
        headerClickHandler: e => {
          var _a;
          const s = e.detail.repeater;
          const items = s.items;
          if (!items) {
            return;
          }
          const selectedItems = (_a = s.selectedItems) !== null && _a !== void 0 ? _a : s.selectedItems = [];
          if (s.allSelected) {
            selectedItems.clear();
            return;
          }
          selectedItems.length = 0;
          selectedItems.push(...items);
          selectedItems.refresh();
        },
        cellRenderer: () => XNode.create(SelectorCheckBox, null)
      });
      _export("default", DataGrid = class DataGrid extends TableRepeater {
        constructor(app, e = document.createElement("table")) {
          super(app, e);
        }
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          if (name === "columns") {
            super.onPropertyChanged("header");
            super.onPropertyChanged("footer");
            super.onPropertyChanged("items");
          }
          if (name === "orderBy") {
            if (!this.orderBySet) {
              this.onPropertyChanged("header");
            }
            this.orderBySet = true;
          }
        }
        preCreate() {
          super.preCreate();
          this.header = true;
          this.footer = null;
          this.element.dataset.dataGrid = "data-grid";
          this.headerRenderer = item => {
            var _a, _b, _c;
            return XNode.create("tr", null, ...((_c = (_b = (_a = this.columns) === null || _a === void 0 ? void 0 : _a.map) === null || _b === void 0 ? void 0 : _b.call(_a, x => {
              var _a, _b, _c, _d, _e;
              if (x.headerRenderer === void 0) {
                x.headerRenderer = _ => {
                  let order = this.orderBy;
                  if (order !== void 0) {
                    if (order === x.headerSort) {
                      order = true;
                    } else if (order === x.headerSortDescending) {
                      order = false;
                    }
                  }
                  return XNode.create("th", null, XNode.create("span", {
                    "data-recreate": "true",
                    text: x.header,
                    title: x.header
                  }), typeof order === "boolean" && (order ? XNode.create("i", {
                    "data-sort": "up",
                    class: "fa-solid fa-arrow-up-short-wide"
                  }) : XNode.create("i", {
                    "data-sort": "down",
                    class: "fa-solid fa-arrow-down-wide-short"
                  })));
                };
              }
              const node = x.headerRenderer(item);
              const na = (_a = node.attributes) !== null && _a !== void 0 ? _a : node.attributes = {};
              (_b = na["data-click-event"]) !== null && _b !== void 0 ? _b : na["data-click-event"] = getHeaderEventName(x);
              if (x.width !== void 0) {
                (_c = na["style-width"]) !== null && _c !== void 0 ? _c : na["style-width"] = x.width;
              } else {
                if (x.maxWidth !== void 0) {
                  (_d = na["style-max-width"]) !== null && _d !== void 0 ? _d : na["style-max-width"] = x.maxWidth;
                }
                if (x.minWidth !== void 0) {
                  (_e = na["style-min-width"]) !== null && _e !== void 0 ? _e : na["style-min-width"] = x.minWidth;
                }
              }
              return node;
            })) !== null && _c !== void 0 ? _c : []));
          };
          this.itemRenderer = item => {
            var _a, _b, _c;
            return XNode.create("tr", null, ...((_c = (_b = (_a = this.columns) === null || _a === void 0 ? void 0 : _a.map) === null || _b === void 0 ? void 0 : _b.call(_a, x => {
              var _a, _b, _c, _d, _e, _f, _g, _h;
              (_a = x.ellipsis) !== null && _a !== void 0 ? _a : x.ellipsis = true;
              if (x.cellRenderer === void 0) {
                (_b = x.labelPath) !== null && _b !== void 0 ? _b : x.labelPath = i => i[x.label];
                if (x.ellipsis) {
                  x.cellRenderer = i => XNode.create("td", {
                    text: x.labelPath(i)
                  });
                } else {
                  x.cellRenderer = i => XNode.create("td", {
                    text: x.labelPath(i),
                    title: x.labelPath(i)
                  });
                }
              }
              const node = (_c = x.cellRenderer) === null || _c === void 0 ? void 0 : _c.call(x, item);
              const na = (_d = node.attributes) !== null && _d !== void 0 ? _d : node.attributes = {};
              if (x.ellipsis) {
                na["data-ellipsis"] = "true";
              }
              (_e = na["data-click-event"]) !== null && _e !== void 0 ? _e : na["data-click-event"] = getCellEventName(x);
              if (x.width !== void 0) {
                (_f = na["style-width"]) !== null && _f !== void 0 ? _f : na["style-width"] = x.width;
              } else {
                if (x.maxWidth !== void 0) {
                  (_g = na["style-max-width"]) !== null && _g !== void 0 ? _g : na["style-max-width"] = x.maxWidth;
                }
                if (x.minWidth !== void 0) {
                  (_h = na["style-min-width"]) !== null && _h !== void 0 ? _h : na["style-min-width"] = x.minWidth;
                }
              }
              return node;
            })) !== null && _c !== void 0 ? _c : []));
          };
          this.footerRenderer = item => {
            var _a, _b, _c;
            return XNode.create("tr", null, ...((_c = (_b = (_a = this.columns) === null || _a === void 0 ? void 0 : _a.map) === null || _b === void 0 ? void 0 : _b.call(_a, x => {
              var _a, _b;
              const node = (_a = x.footerRenderer) === null || _a === void 0 ? void 0 : _a.call(x, item);
              if (node === void 0) {
                return node;
              }
              const na = (_b = node.attributes) !== null && _b !== void 0 ? _b : node.attributes = {};
              if (na["data-click-event"] === void 0) {
                na["data-click-event"] = getFooterEventName(x);
              }
              return node;
            })) !== null && _c !== void 0 ? _c : []));
          };
        }
        dispatchHeaderFooterEvent(eventName, type, recreate, originalTarget) {
          var _a;
          let detail = this[type];
          const column = this.columns.find(x => getHeaderEventName(x) === eventName || getFooterEventName(x) === eventName);
          let order = this.orderBy;
          const originalOrder = this.orderBy;
          const isHeader = type === "header";
          const setOrderBy = isHeader && column.headerSort !== void 0;
          if (isHeader) {
            if (setOrderBy) {
              if (order === column.headerSortDescending) {
                order = column.headerSort;
              } else if (order === column.headerSort) {
                order = column.headerSortDescending;
              } else {
                order = (_a = column.headerSortDefault) !== null && _a !== void 0 ? _a : column.headerSort;
              }
            }
            detail = {
              repeater: this,
              detail,
              type,
              order
            };
          }
          const ce = new CustomEvent(eventName !== null && eventName !== void 0 ? eventName : `${type}Click`, {
            detail,
            bubbles: this.bubbleEvents,
            cancelable: true
          });
          originalTarget.dispatchEvent(ce);
          if (ce.defaultPrevented) {
            return;
          }
          this.invokeHandler(isHeader ? column.headerClickHandler : column.footerClickHandler, ce);
          if (ce.defaultPrevented) {
            return;
          }
          if (setOrderBy && this.orderBy === originalOrder) {
            this.orderBy = order;
            ce.executed = true;
          }
          if (ce.executed) {
            this.onPropertyChanged(type);
          }
        }
        dispatchItemEvent(eventName, item, recreate, originalTarget) {
          var _a;
          const ce = new CustomEvent(eventName !== null && eventName !== void 0 ? eventName : "itemClick", {
            detail: item,
            bubbles: this.bubbleEvents,
            cancelable: true
          });
          originalTarget.dispatchEvent(ce);
          if (ce.defaultPrevented) {
            return;
          }
          for (const iterator of this.columns) {
            if (getCellEventName(iterator) === eventName) {
              this.invokeHandler(iterator.cellClickHandler, ce);
              break;
            }
          }
          if (ce.defaultPrevented) {
            return;
          }
          if (eventName === "itemSelect" || eventName === "itemDeselect") {
            const si = (_a = this.selectedItems) !== null && _a !== void 0 ? _a : this.selectedItems = [];
            if (si) {
              const index = si.indexOf(item);
              if (index === -1) {
                if (this.allowMultipleSelection) {
                  si.add(item);
                } else {
                  si.set(0, item);
                }
              } else {
                si.removeAt(index);
              }
            }
          }
          if (recreate && ce.executed) {
            this.refreshItem(item, ce.promise);
          }
        }
        invokeHandler(h, e) {
          if (!h) {
            return;
          }
          const p = h(e);
          e.executed = true;
          if (p && p.then) {
            if (e.promise) {
              e.promise = Promise.all([e.promise, p]);
            } else {
              e.promise = p;
            }
            p === null || p === void 0 ? void 0 : p.catch(error => {
              if (CancelToken.isCancelled(error)) {
                return;
              }
              console.error(error);
            });
          }
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Array)], DataGrid.prototype, "columns", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], DataGrid.prototype, "orderBy", void 0);
    }
  };
});
//# sourceMappingURL=DataGrid.js.map