System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "./AtomRepeater", "./styles/drop-down.global.css"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, BindableProperty, XNode, AtomRepeater, askSuggestion, askSuggestionPopup, disposeChildren, MatchAnyCaseInsensitive, DropDown;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
      askSuggestion = _AtomRepeater.askSuggestion;
      askSuggestionPopup = _AtomRepeater.askSuggestionPopup;
      disposeChildren = _AtomRepeater.disposeChildren;
      MatchAnyCaseInsensitive = _AtomRepeater.MatchAnyCaseInsensitive;
    }, function (_stylesDropDownGlobalCss) {}],
    execute: function () {
      _export("default", DropDown = class DropDown extends AtomRepeater {
        constructor() {
          super(...arguments);
          this.isPopupOpen = false;
        }
        updateItems(container) {}
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          switch (name) {
            case "labelPath":
              this.itemRenderer = item => XNode.create("div", {
                text: this.labelPath(item)
              });
              break;
            case "prompt":
              this.updateClasses();
              break;
          }
        }
        preCreate() {
          super.preCreate();
          this.disableSearch = false;
          this.prompt = "Select";
          this.popupSuggestions = true;
          this.bindEvent(this.element, "click", e => this.openPopup(e));
          this.valuePath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item;
          };
          this.labelPath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.label) !== null && _a !== void 0 ? _a : item;
          };
          this.itemRenderer = item => XNode.create("div", {
            text: this.labelPath(item)
          });
          this.element.dataset.dropDown = "drop-down";
          this.render(XNode.create("div", null, XNode.create("div", {
            "data-white-space": "nowrap",
            text: this.prompt
          }), XNode.create("i", {
            class: "fad fa-caret-circle-down"
          })));
        }
        openPopup(e) {
          return __awaiter(this, void 0, void 0, function* () {
            var _a, _b, _c, _d, _e;
            if (this.isPopupOpen) {
              return;
            }
            this.isPopupOpen = true;
            try {
              if (!this.popupSuggestions) {
                const selected = yield askSuggestion(this.items, (_a = this.suggestionRenderer) !== null && _a !== void 0 ? _a : this.itemRenderer, (_b = this.match) !== null && _b !== void 0 ? _b : MatchAnyCaseInsensitive(this.labelPath), {
                  title: (_c = this.suggestionPrompt) !== null && _c !== void 0 ? _c : this.prompt
                });
                this.selectedItem = selected;
                return;
              }
              const selectedItem = yield askSuggestionPopup(this, this.items, (_d = this.suggestionRenderer) !== null && _d !== void 0 ? _d : this.itemRenderer, (_e = this.match) !== null && _e !== void 0 ? _e : MatchAnyCaseInsensitive(this.labelPath), this.selectedItem);
              if (this.selectedItem !== selectedItem) {
                this.selectedItem = selectedItem;
                this.element.dispatchEvent(new CustomEvent("selectionChanged", {
                  bubbles: true,
                  detail: selectedItem,
                  cancelable: true
                }));
              }
            } finally {
              this.isPopupOpen = false;
            }
          });
        }
        updateClasses() {
          var _a;
          disposeChildren(this, this.element);
          const ir = this.itemRenderer;
          if (!ir) {
            return;
          }
          if (!this.selectedItem) {
            this.render(XNode.create("div", null, XNode.create("div", {
              "data-white-space": "nowrap",
              text: this.prompt
            }), XNode.create("i", {
              class: "fad fa-caret-circle-down"
            })));
            return;
          }
          const selectedItem = this.selectedItem;
          const index = this.items.indexOf(selectedItem);
          const node = ir(selectedItem, index, this);
          const na = (_a = node.attributes) !== null && _a !== void 0 ? _a : node.attributes = {};
          if (!na["data-white-space"]) {
            na["data-white-space"] = "nowrap";
          }
          this.render(XNode.create("div", null, node, XNode.create("i", {
            class: "fad fa-caret-circle-down"
          })));
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Boolean)], DropDown.prototype, "popupSuggestions", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], DropDown.prototype, "search", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], DropDown.prototype, "prompt", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], DropDown.prototype, "suggestionPrompt", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DropDown.prototype, "labelPath", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DropDown.prototype, "match", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DropDown.prototype, "suggestionRenderer", void 0);
    }
  };
});
//# sourceMappingURL=DropDown.js.map