System.register(["tslib", "@web-atoms/core/dist/core/XNode", "./AtomRepeater"], function (_export, _context) {
  "use strict";

  var __rest, XNode, getParentRepeaterItem, handlers;
  function getPropertyInfo(propertyPath) {
    if (typeof propertyPath === "string") {
      return {
        key: propertyPath,
        getter: item => item === null || item === void 0 ? void 0 : item[propertyPath],
        setter: (item, value) => {
          if (item) {
            item[propertyPath] = value;
          }
        }
      };
    }
    if (!Array.isArray(propertyPath)) {
      return propertyPath;
    }
    const last = propertyPath.pop();
    let getterIntermediate;
    if (propertyPath.length > 0) {
      getterIntermediate = item => {
        if (!item) {
          return item;
        }
        for (const iterator of propertyPath) {
          item = item[iterator];
          if (!item) {
            return item;
          }
        }
        return item;
      };
    }
    const setter = (item, value) => {
      if (item) {
        if (getterIntermediate) {
          item = getterIntermediate(item);
        }
        if (item) {
          item[last] = value;
        }
      }
    };
    const getter = item => {
      if (!item) {
        return item;
      }
      if (getterIntermediate) {
        item = getterIntermediate(item);
      }
      return item === null || item === void 0 ? void 0 : item[last];
    };
    return {
      key: propertyPath.join(","),
      getter,
      setter
    };
  }
  function registerEvent(property, changeEvents, editorValuePath) {
    var _a;
    (_a = property.key) !== null && _a !== void 0 ? _a : property.key = property.setter + ":" + property.getter;
    const name = `${property.key}:${changeEvents.join(",")}`;
    if (!handlers[name]) {
      handlers[name] = changeEvents;
      for (const iterator of changeEvents) {
        document.body.addEventListener(iterator, e => {
          setTimeout(() => {
            const ri = getParentRepeaterItem(e.target);
            if (!ri) {
              return;
            }
            const [_, repeater, item] = ri;
            const oldValue = property.getter(item);
            const value = editorValuePath(e.target);
            if (oldValue != value) {
              property.setter(item, value);
              repeater.refreshItem(item);
            }
          }, 1);
        }, true);
      }
    }
  }
  function EditableInput(_a) {
    var {
        propertyPath
      } = _a,
      a = __rest(_a, ["propertyPath"]);
    if (typeof propertyPath === "string" || Array.isArray(propertyPath)) {
      propertyPath = getPropertyInfo(propertyPath);
    }
    registerEvent(propertyPath, ["change", "blur"], item => item.value);
    return XNode.create("input", Object.assign({
      type: "text"
    }, a));
  }
  _export({
    getPropertyInfo: getPropertyInfo,
    EditableInput: EditableInput
  });
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      getParentRepeaterItem = _AtomRepeater.getParentRepeaterItem;
    }],
    execute: function () {
      handlers = {};
    }
  };
});
//# sourceMappingURL=Editable.js.map