System.register(["tslib", "@web-atoms/core/dist/core/XNode", "./styles/expander.global.css"], function (_export, _context) {
  "use strict";

  var __rest, XNode;
  function Expander(_a, header, detail) {
    var _b, _c;
    var {
        icon,
        isExpanded
      } = _a,
      a = __rest(_a, ["icon", "isExpanded"]);
    if (!detail) {
      throw new Error("Expander must contain two children, one header and one detail");
    }
    const ha = (_b = header.attributes) !== null && _b !== void 0 ? _b : header.attributes = {};
    const da = (_c = detail.attributes) !== null && _c !== void 0 ? _c : detail.attributes = {};
    ha["data-element"] = "header";
    da["data-element"] = "detail";
    const iconElement = !icon ? [] : (Array.isArray(icon) ? icon : [icon]).map(i => XNode.create("i", {
      "data-element": "icon",
      class: i
    }));
    return XNode.create("div", Object.assign({
      "data-is-expander": "expander",
      "data-is-expanded": isExpanded
    }, a), ...iconElement, header, XNode.create("i", {
      "data-element": "caret",
      class: "fas fa-angle-down"
    }), detail);
  }
  function ExpanderMenu(_a, header, ...details) {
    var _b, _c;
    var {
        icon,
        isExpanded
      } = _a,
      a = __rest(_a, ["icon", "isExpanded"]);
    if (details.length === 0) {
      throw new Error("Expander must contain two children, one header and one detail");
    }
    const ha = (_b = header.attributes) !== null && _b !== void 0 ? _b : header.attributes = {};
    ha["data-element"] = "header";
    let i = 2;
    details = details.filter(x => x !== false);
    for (const iterator of details) {
      const ia = (_c = iterator.attributes) !== null && _c !== void 0 ? _c : iterator.attributes = {};
      ia["data-element"] = "detail";
      ia["style-grid-row-start"] = (i++).toString();
    }
    const iconElement = !icon ? [] : (Array.isArray(icon) ? icon : [icon]).map(i => XNode.create("i", {
      "data-element": "icon",
      class: i
    }));
    return XNode.create("div", Object.assign({
      "data-is-expander": "menu",
      "data-is-expanded": isExpanded
    }, a), ...iconElement, header, XNode.create("i", {
      "data-element": "caret",
      class: "fas fa-angle-down"
    }), ...details);
  }
  _export({
    default: Expander,
    ExpanderMenu: ExpanderMenu
  });
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_stylesExpanderGlobalCss) {}],
    execute: function () {
      document.body.addEventListener("click", e => {
        if (e.defaultPrevented) {
          return;
        }
        let start = e.target;
        while (start) {
          if (/icon|caret|header/.test(start.getAttribute("data-element"))) {
            break;
          }
          start = start.parentElement;
        }
        start = start === null || start === void 0 ? void 0 : start.parentElement;
        if (!start) {
          return;
        }
        const isExpander = start === null || start === void 0 ? void 0 : start.getAttribute("data-is-expander");
        if (!/^(menu|expander)$/i.test(isExpander)) {
          return;
        }
        const ds = start.dataset;
        if (/menu/i.test(isExpander)) {
          e.preventDefault();
          e.stopImmediatePropagation();
        }
        if (ds.isExpanded === "false") {
          start.dispatchEvent(new CustomEvent("expanded", {
            bubbles: true,
            cancelable: true
          }));
        } else {
          start.dispatchEvent(new CustomEvent("collapsed", {
            bubbles: true,
            cancelable: true
          }));
        }
      }, {
        capture: true
      });
      document.body.addEventListener("expanded", ce => {
        if (ce.defaultPrevented) {
          return;
        }
        const target = ce.target;
        target.dataset.isExpanded = "true";
      });
      document.body.addEventListener("collapsed", ce => {
        if (ce.defaultPrevented) {
          return;
        }
        const target = ce.target;
        target.dataset.isExpanded = "false";
      });
    }
  };
});
//# sourceMappingURL=Expander.js.map