System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/StringHelper", "@web-atoms/core/dist/core/XNode", "../styles/form.global.css"], function (_export, _context) {
  "use strict";

  var __rest, Bind, StringHelper, XNode, checkClick, BindError, BindEmailError;
  function Form(_a, ...nodes) {
    var {
        "data-submit-event": submitEvent = "submitForm",
        "data-show-validation": showValidation = "false",
        "data-error-message": errorMessage = "Please fix all validations"
      } = _a,
      a = __rest(_a, ["data-submit-event", "data-show-validation", "data-error-message"]);
    return XNode.create("div", Object.assign({}, a, {
      "data-submit-event": submitEvent,
      "data-form": "form",
      "data-valid": "true",
      "data-show-validation": showValidation,
      "data-error-message": errorMessage,
      "event-click": checkClick
    }), XNode.create("div", {
      class: "error-message",
      text: errorMessage
    }), ...nodes);
  }
  _export("default", Form);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreStringHelper) {
      StringHelper = _webAtomsCoreDistCoreStringHelper.StringHelper;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_stylesFormGlobalCss) {}],
    execute: function () {
      checkClick = e => {
        var _a;
        const form = e.currentTarget;
        const element = e.target;
        let target = element;
        while (target.tagName !== "BUTTON") {
          target = target.parentElement;
          if (!target || target === form) {
            return;
          }
        }
        const submitEvent = target.getAttribute("data-submit-event");
        if (!submitEvent) {
          if (!/submit/i.test((_a = target.getAttribute("type")) !== null && _a !== void 0 ? _a : target.getAttribute("data-type"))) {
            return;
          }
        }
        form.setAttribute("data-show-validation", "true");
        setTimeout(() => {
          const all = Array.from(form.getElementsByClassName("field-error"));
          for (const iterator of all) {
            if (iterator.textContent) {
              form.setAttribute("data-valid", "false");
              return;
            }
          }
          form.setAttribute("data-valid", "true");
          const eventName = StringHelper.fromHyphenToCamel(submitEvent !== null && submitEvent !== void 0 ? submitEvent : form.getAttribute("data-submit-event"));
          target.dispatchEvent(new CustomEvent(eventName, {
            bubbles: true,
            cancelable: true
          }));
        }, 100);
      };
      _export("BindError", BindError = ({
        value,
        message = (v, l) => `${l} is invalid`,
        isValid = (v, e) => !!v
      }) => {
        function f2(sender, element) {
          var _a;
          const isRequired = element.parentElement.querySelector(`[data-required]`);
          const msg = value.call(this, sender);
          if (!msg) {
            if (!isRequired) {
              return "";
            }
          }
          if (isValid(msg, element)) {
            return "";
          }
          return message(msg, ((_a = element.parentElement.querySelector(`[data-element=label]`)) === null || _a === void 0 ? void 0 : _a.textContent) || "This field ");
        }
        ;
        f2.toString = () => value.toString();
        return Bind.oneWay(f2);
      });
      _export("BindEmailError", BindEmailError = ({
        value,
        message = (v, l) => `${l} is not a valid email address`,
        isValid = (v, e) => /[^\@]+\@[^\@]+\.[^\@]+/i.test(v)
      }) => {
        return BindError({
          value,
          message,
          isValid
        });
      });
    }
  };
});
//# sourceMappingURL=Form.js.map