System.register([], function (_export, _context) {
  "use strict";

  var ItemPath, get;
  function* getFragments(path) {
    const regex = /([^\=\:]+)\s*[\=\:]\s*((('[^\\']*(((\\')|(''))[^\\']*)*')|("[^\\"]*(((\\")|(""))[^\\"]*)*"))|([^\,\;]+))\s*[\,\;]?\s*/gmi;
    let m;
    while ((m = regex.exec(path)) !== null) {
      if (m.index === regex.lastIndex) {
        regex.lastIndex++;
      }
      yield [m[1].trim(), m[2].trim()];
    }
  }
  _export("default", void 0);
  return {
    setters: [],
    execute: function () {
      get = (start, path) => {
        let item = start;
        for (const iterator of path.split(".")) {
          if (iterator === "$") {
            item = start;
            continue;
          }
          item = item[iterator];
        }
        return item;
      };
      _export("default", ItemPath = class ItemPath {
        static get(item, path) {
          if (path.startsWith("$.")) {
            return get(item, path);
          }
          if (/^[\{\"]/.test(path)) {
            const json = JSON.parse(path);
            return json;
          }
          const target = {};
          this.build(item, path, target);
          return target;
        }
        static build(item, path, target) {
          for (let [key, value] of getFragments(path)) {
            if (value.startsWith("$")) {
              value = get(item, value);
              target[key] = value;
              continue;
            }
            if (value.startsWith('"')) {
              value = JSON.parse(value);
              target[key] = value;
              continue;
            }
            if (value.startsWith("'")) {
              value = value.substring(1, value.length - 1);
              value = value.replace(/((\'\')|(\\\'))/, "'");
              target[key] = value;
              continue;
            }
            if (value === "true") {
              target[key] = true;
              continue;
            }
            if (value === "false") {
              target[key] = false;
              continue;
            }
            if (value === "null") {
              target[key] = null;
              continue;
            }
            target[key] = Number(value);
          }
        }
      });
    }
  };
});
//# sourceMappingURL=ItemPath.js.map