System.register(["tslib", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl"], function (_export, _context) {
  "use strict";

  var __rest, XNode, AtomControl, updateMask, maskProperty;
  function MaskedInput(_a) {
    var {
        mask
      } = _a,
      a = __rest(_a, ["mask"]);
    return XNode.create("div", Object.assign({
      "data-mask": mask
    }, maskProperty(mask)), XNode.create("input", Object.assign({
      "data-mask": mask
    }, a)));
  }
  _export("default", MaskedInput);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }],
    execute: function () {
      updateMask = e => {
        const target = e.target;
        const mask = target.dataset.mask;
        if (!mask) {
          return;
        }
        let result = "";
        const value = target.value;
        for (let index = 0, elementIndex = 0; elementIndex < value.length; elementIndex++, index++) {
          const element = value[elementIndex];
          const maskElement = mask[index];
          switch (maskElement) {
            case "#":
              result += /[0-9]/.test(element) ? element : "0";
              continue;
            case ".":
              if (element !== ".") {
                result += ".";
              }
              result += element;
              break;
            default:
              result += element;
              break;
          }
        }
        target.parentElement.dataset.label = result;
      };
      document.body.addEventListener("change", updateMask);
      document.body.addEventListener("keypress", updateMask);
      document.body.addEventListener("keyup", updateMask);
      maskProperty = AtomControl.registerProperty("data-mask", "format", (ctrl, e, value) => {
        if (!value) {
          e.dataset.label = "";
          return;
        }
        let result = "";
        for (const iterator of value) {
          switch (iterator) {
            case "#":
              result += " ";
              continue;
            case "0":
              result += "0";
              continue;
            default:
              result += iterator;
              continue;
          }
        }
        e.dataset.label = result;
      });
    }
  };
});
//# sourceMappingURL=MaskedInputDiv.js.map