System.register(["tslib", "@web-atoms/core/dist/core/XNode", "./styles/password-box.global.css"], function (_export, _context) {
  "use strict";

  var __rest, XNode;
  function PasswordBox(_a) {
    var {
        placeholder,
        value,
        autofocus
      } = _a,
      a = __rest(_a, ["placeholder", "value", "autofocus"]);
    return XNode.create("div", Object.assign({
      "data-password-box": "password-box"
    }, a), XNode.create("input", {
      placeholder: placeholder,
      autofocus: autofocus,
      type: "password",
      value: value
    }), XNode.create("i", {
      class: "fa-solid fa-eye",
      title: "Display Password",
      "data-click-event": "togglePassword",
      "data-password-hint": "password-hint"
    }));
  }
  _export("default", PasswordBox);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_stylesPasswordBoxGlobalCss) {}],
    execute: function () {
      document.body.addEventListener("togglePassword", e => {
        const current = e.target;
        const input = current.previousElementSibling;
        if ((input === null || input === void 0 ? void 0 : input.tagName) !== "INPUT") {
          return;
        }
        const isPassword = input.type === "password";
        input.type = isPassword ? "text" : "password";
        current.className = !isPassword ? "fa-solid fa-eye" : "fa-solid fa-eye-slash";
        current.title = !isPassword ? "Display Password" : "Hide Password";
      });
    }
  };
});
//# sourceMappingURL=PasswordBox.js.map