System.register(["@web-atoms/core/dist/core/XNode", "./AtomRepeater", "./styles/radio-button-list.global.css"], function (_export, _context) {
  "use strict";

  var XNode, AtomRepeater, RadioButtonList;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
    }, function (_stylesRadioButtonListGlobalCss) {}],
    execute: function () {
      _export("default", RadioButtonList = class RadioButtonList extends AtomRepeater {
        preCreate() {
          super.preCreate();
          this.valuePath = item => {
            var _a;
            return (_a = item === null || item === void 0 ? void 0 : item.value) !== null && _a !== void 0 ? _a : item;
          };
          this.bindEvent(this.element, "itemClick", e => {
            const s = this.selectedItems;
            if (!s) {
              return;
            }
            const item = e.detail;
            const old = this.selectedItem;
            if (old) {
              this.element.dispatchEvent(new CustomEvent("itemDeselect", {
                detail: old,
                bubbles: false
              }));
            }
            this.selectedItem = item;
            this.element.dispatchEvent(new CustomEvent("itemSelect", {
              detail: item,
              bubbles: false
            }));
          });
          this.element.dataset.radioButtonList = "radio-button-list";
          this.itemRenderer = item => XNode.create("div", {
            "data-item-type": "radio"
          }, XNode.create("i", {
            class: "far fa-dot-circle"
          }), XNode.create("i", {
            class: "far fa-circle"
          }), XNode.create("span", {
            text: item.label
          }));
        }
      });
    }
  };
});
//# sourceMappingURL=RadioButtonList.js.map