System.register(["tslib"], function (_export, _context) {
  "use strict";

  var __awaiter, RefreshLock;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }],
    execute: function () {
      _export("default", RefreshLock = class RefreshLock {
        constructor(app, e) {
          this.app = app;
          this.map = new Map();
          this.begin = ce => {
            if (ce.target === ce.currentTarget) {
              return;
            }
            const previous = this.promise;
            this.promise = this.setupNew(previous, ce.detail.id);
            this.app.runAsync(() => this.promise);
          };
          this.end = ce => {
            if (ce.target === ce.currentTarget) {
              return;
            }
            const resolver = this.map.get(ce.detail.id);
            resolver === null || resolver === void 0 ? void 0 : resolver();
          };
          e.addEventListener("refreshLockBegin", this.begin);
          e.addEventListener("refreshLockEnd", this.end);
          this.dispose = () => {
            e.removeEventListener("refreshLockBegin", this.begin);
            e.removeEventListener("refreshLockEnd", this.begin);
          };
        }
        queue(fx) {
          if (this.promise) {
            this.promise.then(fx);
            return;
          }
          fx();
        }
        setupNew(previous, id) {
          return __awaiter(this, void 0, void 0, function* () {
            if (previous) {
              yield previous;
            }
            yield new Promise((resolve, reject) => {
              this.map.set(id, resolve);
            });
            this.map.delete(id);
            this.promise = null;
          });
        }
      });
    }
  };
});
//# sourceMappingURL=RefreshLock.js.map