System.register(["tslib", "@web-atoms/core/dist/core/AtomDisposableList", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "../mobile-app/MobileApp", "../styles/resizable.global.css"], function (_export, _context) {
  "use strict";

  var __rest, AtomDisposableList, XNode, AtomControl, isMobileView, pointerDown;
  function resizable(_a, child) {
    var {
        direction = "horizontal"
      } = _a,
      a = __rest(_a, ["direction"]);
    if (isMobileView) {
      return child;
    }
    return XNode.create("div", Object.assign({}, a, {
      "data-resizable": "resizable",
      "data-direction": direction
    }), child, XNode.create("div", {
      "data-element": "resizer",
      "event-pointerdown": pointerDown
    }));
  }
  _export("default", resizable);
  return {
    setters: [function (_tslib) {
      __rest = _tslib.__rest;
    }, function (_webAtomsCoreDistCoreAtomDisposableList) {
      AtomDisposableList = _webAtomsCoreDistCoreAtomDisposableList.AtomDisposableList;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_mobileAppMobileApp) {
      isMobileView = _mobileAppMobileApp.isMobileView;
    }, function (_stylesResizableGlobalCss) {}],
    execute: function () {
      pointerDown = e => {
        const target = e.currentTarget;
        const direction = target.getAttribute("data-direction");
        const previous = target.parentElement;
        const disposables = new AtomDisposableList();
        const {
          x,
          y
        } = e;
        const width = previous.clientWidth;
        const control = AtomControl.from(target);
        target.setPointerCapture(e.pointerId);
        target.setAttribute("data-resizing", "1");
        disposables.add(() => {
          target.removeAttribute("data-resizing");
          target.releasePointerCapture(e.pointerId);
        });
        disposables.add(control.bindEvent(target, "pointermove", ep => {
          const diff = ep.x - x;
          previous.style.width = width + diff + "px";
        }));
        disposables.add(control.bindEvent(target, "pointerup", ep => {
          const diff = ep.x - x;
          previous.style.width = width + diff + "px";
          disposables.dispose();
        }));
      };
    }
  };
});
//# sourceMappingURL=Resizable.js.map