System.register(["@web-atoms/core/dist/core/XNode", "./styles/swipe.global.css"], function (_export, _context) {
  "use strict";

  var XNode, swipeStart;
  function SwipeLeft(a, ...nodes) {
    return XNode.create("div", Object.assign({
      "data-swipe": "left"
    }, a), ...nodes);
  }
  _export("SwipeLeft", SwipeLeft);
  return {
    setters: [function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_stylesSwipeGlobalCss) {}],
    execute: function () {
      swipeStart = null;
      document.body.addEventListener("touchstart", e => {
        let element = e.target;
        if (e.touches.length > 1) {
          return;
        }
        while (element) {
          if (element.dataset.swipe) {
            break;
          }
          element = element.parentElement;
        }
        if (!element) {
          return;
        }
        const {
          left
        } = element.getBoundingClientRect();
        swipeStart = {
          element,
          x: e.touches[0].screenX - left
        };
      });
      document.body.addEventListener("touchmove", e => {
        let element = e.target;
        if (!swipeStart || e.touches.length > 1) {
          return;
        }
        let swipe;
        while (element) {
          swipe = element.dataset.swipe;
          if (swipe) {
            break;
          }
          element = element.parentElement;
        }
        if (!element) {
          return;
        }
        const {
          left
        } = element.getBoundingClientRect();
        const cx = e.touches[0].screenX - left;
        const {
          x
        } = swipeStart;
        let diff = cx - x;
        if (diff > 0) {
          if (swipe !== "right") {
            return;
          }
        } else {
          if (swipe !== "left") {
            return;
          }
          let content = element.firstElementChild;
          let maxMargin = 0;
          let child = content === null || content === void 0 ? void 0 : content.nextElementSibling;
          let count = 0;
          while (child) {
            maxMargin += child.offsetWidth;
            count++;
            child = child.nextElementSibling;
          }
          let margin = -diff;
          if (maxMargin && margin > maxMargin) {
            margin = maxMargin;
          }
          if (margin <= 5) {
            delete content.style.marginRight;
            delete content.style.transform;
            child = content === null || content === void 0 ? void 0 : content.nextElementSibling;
            while (child) {
              delete child.style.marginRight;
              child = child.nextElementSibling;
            }
            return;
          }
          content.style.marginRight = `${margin}px`;
          content.style.transform = `translateX(-${margin}px)`;
          let avgMargin = Math.ceil(margin / count);
          child = content === null || content === void 0 ? void 0 : content.nextElementSibling;
          while (child) {
            count--;
            if (count === 0) {
              break;
            }
            let m = avgMargin * count + 5;
            child.style.marginRight = `${m}px`;
            child = child.nextElementSibling;
          }
        }
      });
      document.body.addEventListener("touchend", e => {
        swipeStart = null;
      });
    }
  };
});
//# sourceMappingURL=Swipe.js.map