System.register(["@web-atoms/core/dist/core/XNode", "./AtomRepeater"], function (_export, _context) {
  "use strict";

  var XNode, AtomRepeater, TableRepeater;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_AtomRepeater) {
      AtomRepeater = _AtomRepeater.default;
    }],
    execute: function () {
      _export("default", TableRepeater = class TableRepeater extends AtomRepeater {
        constructor(app, e = document.createElement("table")) {
          super(app, e);
        }
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          switch (name) {
            case "header":
            case "headerRenderer":
              this.updateHeaderFooter("header", this.headerPresenter, this.header, this.headerRenderer);
              break;
            case "footer":
            case "footerRenderer":
              this.updateHeaderFooter("footer", this.footerPresenter, this.footer, this.footerRenderer);
              break;
          }
        }
        preCreate() {
          super.preCreate();
          this.preRender();
          this.onPropertyChanged("header");
          this.onPropertyChanged("footer");
        }
        preRender() {
          this.element.dataset.tableRepeater = "table-repeater";
          this.render(XNode.create("table", null, XNode.create("thead", null), XNode.create("tbody", null), XNode.create("tfoot", null)));
          this.itemsPresenter = this.element.querySelector("tbody");
          this.headerPresenter = this.element.firstElementChild;
          this.footerPresenter = this.element.lastElementChild;
        }
      });
    }
  };
});
//# sourceMappingURL=TableRepeater.js.map