System.register(["@web-atoms/core/dist/web/controls/AtomControl", "./AtomRepeater", "./styles/tooltip.global.css", "./elements/AtomPopover"], function (_export, _context) {
  "use strict";

  var AtomControl, ElementValueSetters, getParentRepeaterItem, AtomPopover, Tooltip, tooltips;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
      ElementValueSetters = _webAtomsCoreDistWebControlsAtomControl.ElementValueSetters;
    }, function (_AtomRepeater) {
      getParentRepeaterItem = _AtomRepeater.getParentRepeaterItem;
    }, function (_stylesTooltipGlobalCss) {}, function (_elementsAtomPopover) {
      AtomPopover = _elementsAtomPopover.default;
    }],
    execute: function () {
      tooltips = new Map();
      ElementValueSetters.tooltip = (control, e, value) => {
        tooltips.set(e, [{
          control,
          tooltip: undefined
        }, value]);
        control.registerDisposable({
          dispose: () => {
            tooltips.delete(e);
          }
        });
      };
      document.body.addEventListener("pointerenter", ev => Tooltip.showTooltip(ev.target), true);
      document.body.addEventListener("pointerleave", ev => {
        const start = ev.target;
        setTimeout(() => {
          const item = tooltips.get(start);
          if (!item) {
            return;
          }
          const [host] = item;
          if (host.tooltip) {
            host.tooltip.cancel();
            host.tooltip = undefined;
          }
        }, 250);
      }, true);
      _export("default", Tooltip = class Tooltip extends AtomPopover {
        static showTooltip(target) {
          let item;
          while (target) {
            item = tooltips.get(target);
            if (!item) {
              target = target.parentElement;
              continue;
            }
            break;
          }
          if (!item) {
            return;
          }
          const [host, node] = item;
          host.tooltip = node.create(target, {
            dataFactory: () => {
              let data = getParentRepeaterItem(target);
              if (!data) {
                return AtomControl.from(target).data;
              }
              data = data[2];
              return data;
            }
          });
        }
      });
    }
  };
});
//# sourceMappingURL=Tooltip.js.map