System.register(["tslib", "@web-atoms/core/dist/core/AtomDisposableList", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "./AtomPopover.css", "./relativeRect", "./getContainingBlock"], function (_export, _context) {
  "use strict";

  var __awaiter, AtomDisposableList, CancelToken, XNode, xnodeSymbol, AtomControl, ElementValueSetters, relativeRect, getContainingBlock, AtomPopoverElement, AtomPopover, existingPopup;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreAtomDisposableList) {
      AtomDisposableList = _webAtomsCoreDistCoreAtomDisposableList.AtomDisposableList;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
      xnodeSymbol = _webAtomsCoreDistCoreXNode.xnodeSymbol;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
      ElementValueSetters = _webAtomsCoreDistWebControlsAtomControl.ElementValueSetters;
    }, function (_AtomPopoverCss) {}, function (_relativeRect) {
      relativeRect = _relativeRect.relativeRect;
    }, function (_getContainingBlock) {
      getContainingBlock = _getContainingBlock.default;
    }],
    execute: function () {
      ElementValueSetters["anchor-left"] = (c, e, v) => e.setAttribute("anchor-left", v);
      ElementValueSetters["anchor-right"] = (c, e, v) => e.setAttribute("anchor-right", v);
      ElementValueSetters["anchor-top"] = (c, e, v) => e.setAttribute("anchor-top", v);
      ElementValueSetters["anchor-bottom"] = (c, e, v) => e.setAttribute("anchor-bottom", v);
      AtomPopoverElement = class AtomPopoverElement extends HTMLElement {
        constructor() {
          super(...arguments);
          this.aborted = "cancel";
          this.closePopover = e => {
            const cancelOnBlur = /^(true|yes|1)$/i.test(this.getAttribute("cancel-on-blur") || "true");
            if (!cancelOnBlur) {
              return;
            }
            setTimeout(() => {
              let target = e.target;
              while (target) {
                if (target.hasAttribute("data-close-on-click")) {
                  break;
                }
                if (target === this.parentElement) {
                  return;
                }
                target = target.parentElement;
              }
              this.lastParent = null;
              const ce = new CustomEvent("removing", {
                detail: {
                  result: this.result,
                  aborted: this.aborted
                },
                bubbles: true,
                cancelable: true
              });
              this.dispatchEvent(ce);
              if (ce.defaultPrevented) {
                return;
              }
              this.dispatchEvent(new CustomEvent("removed", {
                detail: {
                  result: this.result,
                  aborted: this.aborted
                },
                bubbles: true
              }));
              this.remove();
            }, 250);
          };
          this.updatePosition = () => {
            if (!this.parentElement) {
              return;
            }
            const lastParent = this.lastParent = this.parentElement;
            if (!lastParent) {
              return;
            }
            const cb = getContainingBlock(lastParent);
            if (!cb) {
              return;
            }
            this.containingBlock = cb;
            const cbr = cb.getBoundingClientRect();
            const rrSelf = relativeRect(this, cb);
            const rrParent = relativeRect(this.parentElement, cb);
            const firstChild = this.firstElementChild.getBoundingClientRect();
            let diffTop = Math.min(window.visualViewport.height, cbr.height) - (rrParent.top + firstChild.height);
            if (diffTop > 0) {
              diffTop = 0;
            } else {
              diffTop -= 40;
            }
            let diffBottom = rrParent.top - firstChild.height;
            if (diffBottom > 0) {
              diffBottom = 0;
            }
            const topLeft = {
              "parent-left": `${rrParent.left}px`,
              "parent-right": `${rrSelf.left}px`,
              "parent-top": `${rrParent.top + diffTop}px`,
              "parent-bottom": `${rrParent.top + rrParent.height + diffTop}px`
            };
            const bottomRight = {
              "parent-left": `${rrParent.right}px`,
              "parent-right": `${rrSelf.right}px`,
              "parent-top": `${rrParent.bottom + rrSelf.height + diffBottom}px`,
              "parent-bottom": `${rrParent.bottom + rrParent.height + diffBottom}px`
            };
            let anchorBottom = this.getAttribute("anchor-bottom");
            let anchorRight = this.getAttribute("anchor-right");
            let anchorTop = this.getAttribute("anchor-top");
            let anchorLeft = this.getAttribute("anchor-left");
            const style = this.slotElement.style;
            style.removeProperty("left");
            style.removeProperty("top");
            style.removeProperty("right");
            style.removeProperty("bottom");
            if (!anchorBottom) {
              anchorTop || (anchorTop = "parent-bottom");
            }
            if (!anchorRight) {
              anchorLeft || (anchorLeft = "parent-right");
            }
            if (anchorTop) {
              style.top = topLeft[anchorTop];
            }
            if (anchorLeft) {
              style.left = topLeft[anchorLeft];
            }
            if (anchorBottom) {
              style.bottom = bottomRight[anchorBottom];
            }
            if (anchorRight) {
              style.right = bottomRight[anchorRight];
            }
          };
        }
        connectedCallback() {
          if (!this.root) {
            const root = this.root = this.attachShadow({
              mode: "open"
            });
            const slot = document.createElement("slot");
            slot.setAttribute("part", "container");
            this.slotElement = slot;
            root.appendChild(slot);
          }
          setTimeout(() => this.updatePosition(), 100);
          window.addEventListener("scroll", this.updatePosition, {
            passive: true,
            capture: true
          });
          setTimeout(() => {
            document.body.addEventListener("click", this.closePopover);
          }, 100);
        }
        disconnectedCallback() {
          var _a;
          if ((_a = this.lastParent) === null || _a === void 0 ? void 0 : _a.isConnected) {
            this.dispatchEvent(new CustomEvent("removed", {
              detail: {
                result: this.result,
                aborted: this.aborted
              },
              bubbles: true
            }));
          }
          document.body.removeEventListener("click", this.closePopover);
          window.removeEventListener("scroll", this.updatePosition);
          clearInterval(this.timer);
        }
      };
      existingPopup = Symbol("popup");
      _export("default", AtomPopover = class AtomPopover {
        static create(parent, options = {}) {
          var _a;
          return (_a = parent[existingPopup]) !== null && _a !== void 0 ? _a : parent[existingPopup] = new this(parent, options);
        }
        static show(parent, options = {}) {
          var _a;
          const p = (_a = parent[existingPopup]) !== null && _a !== void 0 ? _a : parent[existingPopup] = new this(parent, options);
          return p.resultPromise;
        }
        static menu(parent, node, options = {}) {
          const ct = new CancelToken();
          options.nodeFactory = () => node;
          const p = new this(parent, options);
          p.result = 1;
          p.disposables.add(p.owner.bindEvent(p.popover, "click", () => {
            setTimeout(() => {
              ct.cancel();
            }, 10);
          }));
          return p;
        }
        set renderer(v) {
          var _a, _b;
          const owner = this.owner;
          let first = this.popoverContainer.firstElementChild;
          while (first) {
            const next = first.nextElementSibling;
            owner.dispose(first);
            first.remove();
            first = next;
          }
          if (!v) {
            return;
          }
          if (v[xnodeSymbol]) {
            this.owner.render(XNode.create("div", null, " ", v, " "), this.popoverContainer, this.owner);
          } else {
            this.popoverContainer.appendChild(v);
          }
          (_b = (_a = this.popoverContainer).updatePosition) === null || _b === void 0 ? void 0 : _b.call(_a);
        }
        constructor(parent, options = {}) {
          var _a, _b;
          this.disposables = new AtomDisposableList();
          this.removing = ce => {
            var _a;
            if (this.cancel) {
              ce === null || ce === void 0 ? void 0 : ce.preventDefault();
              const c = (_a = this.cancel) === null || _a === void 0 ? void 0 : _a.call(this);
              if (c === null || c === void 0 ? void 0 : c.then) {
                c.then(() => {
                  this.renderer = void 0;
                  this.remove();
                }, console.warn);
              }
            }
          };
          this.remove = () => {
            var _a, _b;
            const {
              result
            } = this.popover;
            if (result === void 0) {
              (_a = this.resultReject) === null || _a === void 0 ? void 0 : _a.call(this, "canceled");
            } else {
              (_b = this.resultResolve) === null || _b === void 0 ? void 0 : _b.call(this, result);
            }
            this.disposables.dispose();
            this.popover.remove();
          };
          const p1 = parent;
          this.disposables.add(() => p1[existingPopup] = null);
          if (parent instanceof AtomControl) {
            this.owner = parent;
            parent = this.owner.element;
          } else {
            this.owner = AtomControl.from(parent);
          }
          const popover = this.popover = document.createElement("atom-pop-over");
          this.popoverContainer = popover;
          parent.appendChild(popover);
          const {
            cancelToken,
            nodeFactory,
            dataFactory,
            closeOnClick = true,
            "anchor-left": anchorLeft,
            "anchor-right": anchorRight,
            "anchor-top": anchorTop,
            "anchor-bottom": anchorBottom
          } = options;
          cancelToken === null || cancelToken === void 0 ? void 0 : cancelToken.registerForCancel(this.removing);
          if (anchorLeft) {
            popover.setAttribute("anchor-left", anchorLeft);
          }
          if (anchorRight) {
            popover.setAttribute("anchor-right", anchorRight);
          }
          if (anchorTop) {
            popover.setAttribute("anchor-top", anchorTop);
          }
          if (anchorBottom) {
            popover.setAttribute("anchor-bottom", anchorBottom);
          }
          if (closeOnClick) {
            popover.setAttribute("data-close-on-click", "1");
          }
          popover.addEventListener("removing", this.removing);
          popover.addEventListener("removed", this.remove);
          this.disposables.add(() => {
            popover.removeEventListener("removed", this.remove);
            popover.removeEventListener("removing", this.removing);
          });
          (_a = this.init) !== null && _a !== void 0 ? _a : this.init = data => {
            if (nodeFactory) {
              this.renderer = nodeFactory(data);
            }
          };
          const p = (_b = this.init) === null || _b === void 0 ? void 0 : _b.call(this, dataFactory === null || dataFactory === void 0 ? void 0 : dataFactory());
          if (p === null || p === void 0 ? void 0 : p.then) {
            p.then(() => void 0, console.warn);
          }
          this.resultPromise = new Promise((resolve, reject) => {
            this.resultResolve = resolve;
            this.resultReject = reject;
          });
          this.resultPromise.catch(() => void 0);
        }
        close(r) {
          this.popover.result = r !== null && r !== void 0 ? r : null;
          this.popover.remove();
        }
        cancel() {
          return __awaiter(this, void 0, void 0, function* () {
            delete this.popover.result;
            this.popover.remove();
          });
        }
      });
      customElements.define("atom-pop-over", AtomPopoverElement);
    }
  };
});
//# sourceMappingURL=AtomPopover.js.map