System.register(["@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomComboBox", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/controls/AtomItemsControl", "./AtomCalendarStyle", "./CalendarViewModel", "./res/SRCalendar"], function (_export, _context) {
  "use strict";

  var Bind, XNode, AtomComboBox, AtomControl, AtomItemsControl, AtomCalendarStyle, CalendarViewModel, SRCalendar, AtomCalendar, BindCalendar;
  return {
    setters: [function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomComboBox) {
      AtomComboBox = _webAtomsCoreDistWebControlsAtomComboBox.AtomComboBox;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebControlsAtomItemsControl) {
      AtomItemsControl = _webAtomsCoreDistWebControlsAtomItemsControl.AtomItemsControl;
    }, function (_AtomCalendarStyle) {
      AtomCalendarStyle = _AtomCalendarStyle.default;
    }, function (_CalendarViewModel) {
      CalendarViewModel = _CalendarViewModel.default;
    }, function (_resSRCalendar) {
      SRCalendar = _resSRCalendar.default;
    }],
    execute: function () {
      BindCalendar = Bind.forLocalViewModel();
      AtomCalendar = class AtomCalendar extends AtomControl {
        create() {
          this.srCalendar = this.app.resolve(SRCalendar);
          this.localViewModel = this.resolve(CalendarViewModel, "owner");
          this.defaultControlStyle = AtomCalendarStyle;
          this.selectedDate = null;
          this.yearStart = -10;
          this.yearEnd = 10;
          this.enableFunc = null;
          this.render(XNode.create(AtomCalendar, {
            styleClass: Bind.oneWay(() => this.controlStyle.name)
          }, XNode.create(AtomCalendar.itemTemplate, null, XNode.create("div", {
            eventClick: BindCalendar.event(x => x.localViewModel.dateClicked(x.data))
          }, XNode.create("div", {
            text: BindCalendar.oneTime(x => x.data.label),
            class: BindCalendar.oneWay(x => ({
              "date-css": 1,
              "is-other-month": x.data.isOtherMonth,
              "is-today": x.data.isToday,
              "is-weekend": x.data.isWeekend,
              "is-selected": x.localViewModel.selectedDate == x.data.value,
              "is-disabled": x.localViewModel.enableFunc ? x.localViewModel.enableFunc(x.data) : 0
            }))
          }))), XNode.create("div", {
            class: "header"
          }, XNode.create("i", {
            eventClick: Bind.event(() => this.localViewModel.changeMonth(-1)),
            class: "fas fa-caret-left",
            title: "Previous Month",
            style: "margin-right: 15px; font-size: 120%; cursor: pointer; padding:0 10px 0 10px;"
          }), XNode.create(AtomComboBox, {
            valuePath: "value",
            value: Bind.twoWays(() => this.localViewModel.year),
            items: Bind.oneWay(() => this.localViewModel.yearList),
            for: "select"
          }, XNode.create(AtomComboBox.itemTemplate, null, XNode.create("option", {
            text: Bind.oneTime(x => x.data.label)
          }))), XNode.create(AtomComboBox, {
            valuePath: "value",
            value: Bind.twoWays(() => this.localViewModel.month),
            items: Bind.oneTime(() => this.srCalendar.monthList),
            for: "select"
          }, XNode.create(AtomComboBox.itemTemplate, null, XNode.create("option", {
            text: Bind.oneTime(x => x.data.label)
          }))), XNode.create("i", {
            eventClick: Bind.event(() => this.localViewModel.changeMonth(1)),
            class: "fas fa-caret-right",
            title: "Next Month",
            style: "margin-left: 15px; font-size: 120%; cursor: pointer; padding:0 10px 0 10px;"
          })), XNode.create(AtomItemsControl, {
            items: Bind.oneTime(() => this.srCalendar.weekDays),
            class: "week-days",
            for: "div"
          }), XNode.create(AtomItemsControl, {
            class: "month-days",
            itemTemplate: Bind.oneWay(() => this.itemTemplate),
            items: Bind.oneWay(() => this.localViewModel.items),
            for: "div"
          })));
        }
        preCreate() {
          this.selectedDate = null;
          this.yearStart = null;
          this.yearStart = null;
          this.enableFunc = null;
          this.currentDate = null;
          this.itemTemplate = null;
        }
      };
      AtomCalendar.itemTemplate = XNode.prepare("itemTemplate", true, true);
      _export("default", AtomCalendar);
    }
  };
});
//# sourceMappingURL=AtomCalendar.js.map