System.register(["@web-atoms/core/dist/core/Colors", "@web-atoms/core/dist/web/styles/AtomStyle"], function (_export, _context) {
  "use strict";

  var Colors, AtomStyle, AtomCalendarStyle;
  _export("default", void 0);
  return {
    setters: [function (_webAtomsCoreDistCoreColors) {
      Colors = _webAtomsCoreDistCoreColors.default;
    }, function (_webAtomsCoreDistWebStylesAtomStyle) {
      AtomStyle = _webAtomsCoreDistWebStylesAtomStyle.AtomStyle;
    }],
    execute: function () {
      _export("default", AtomCalendarStyle = class AtomCalendarStyle extends AtomStyle {
        get theme() {
          return this.styleSheet;
        }
        get root() {
          const existing = this.calendarContainer;
          return Object.assign(Object.assign({}, existing), {
            backgroundColor: Colors.white,
            subclasses: Object.assign(Object.assign({}, existing.subclasses), {
              " .is-disabled ": {
                textDecoration: "line-through"
              },
              " .week-days": {
                subclasses: {
                  " > div": {
                    display: "inline-block",
                    border: "none",
                    color: Colors.black,
                    fontWeight: "bold",
                    fontSize: "75%",
                    textAlign: "center",
                    borderRadius: 0,
                    backgroundColor: Colors.rgba(232, 232, 232),
                    width: "14%",
                    paddingTop: "1%",
                    paddingBottom: "1%"
                  }
                }
              },
              " .month-days": {
                marginTop: "0.5%",
                marginBottom: "0.5%",
                subclasses: {
                  " > div": {
                    width: "14%",
                    minHeight: "28px",
                    display: "inline-block",
                    borderRadius: "50%",
                    backgroundColor: Colors.white,
                    cursor: "default",
                    color: Colors.black,
                    subclasses: {
                      " > div": {
                        borderRadius: "50%",
                        width: "61%",
                        display: "block",
                        padding: "7%",
                        paddingLeft: "2%",
                        paddingRight: "2%",
                        subclasses: {
                          ".date-css": {
                            display: "inline-block",
                            fontSize: "75%",
                            textAlign: "center"
                          },
                          ".is-today": {
                            fontWeight: "bold",
                            color: Colors.rgba(27, 177, 177)
                          },
                          ".is-weekend": {
                            color: "#a50000"
                          },
                          ".shoot": Object.assign({
                            backgroundColor: "#093"
                          }, this.typeStyle),
                          ".audition": Object.assign({
                            backgroundColor: "#6f6ffb"
                          }, this.typeStyle),
                          ".option": Object.assign({
                            backgroundColor: "#3bc3c3"
                          }, this.typeStyle),
                          ".callback": Object.assign({
                            backgroundColor: "#ffa401"
                          }, this.typeStyle),
                          ".test-shoot": Object.assign({
                            backgroundColor: "#ff96aa"
                          }, this.typeStyle),
                          ".personal": Object.assign({
                            backgroundColor: "#fab5be"
                          }, this.typeStyle),
                          ".go-see": Object.assign({
                            backgroundColor: "#fab0fb"
                          }, this.typeStyle),
                          ".training": Object.assign({
                            backgroundColor: "#d1cebc"
                          }, this.typeStyle),
                          ".wardrobe": Object.assign({
                            backgroundColor: "#bbdf49"
                          }, this.typeStyle),
                          ".rehearsal": Object.assign({
                            backgroundColor: "#39f"
                          }, this.typeStyle),
                          ".travel": Object.assign({
                            backgroundColor: "#c7894b"
                          }, this.typeStyle),
                          ".is-other-month": {
                            color: Colors.gray
                          },
                          ".is-selected": {
                            border: "1px solid",
                            borderColor: Colors.gray,
                            fontWeight: "bold",
                            backgroundColor: Colors.white,
                            color: Colors.rgba(185, 149, 93)
                          }
                        }
                      }
                    }
                  }
                }
              }
            })
          });
        }
        get typeStyle() {
          return {
            color: "#fff",
            padding: "10%",
            paddingLeft: "0",
            paddingRight: "0"
          };
        }
        get calendarContainer() {
          return {
            minWidth: "305px",
            textAlign: "center",
            fontFamily: "'Muli', sans-serif",
            boxSizing: "content-box",
            border: "1px solid",
            borderColor: Colors.rgba(232, 232, 232),
            subclasses: {
              " .header": {
                textAlign: "center",
                padding: "1%",
                subclasses: {
                  " > span": {
                    display: "inline-block",
                    marginTop: "1%",
                    padding: "3%",
                    width: "4%",
                    background: "transparent no-repeat"
                  },
                  " .previous-btn": {
                    marginLeft: "3%",
                    float: "left"
                  },
                  " .next-btn": {
                    marginRight: "3%",
                    float: "right"
                  },
                  " > select": {
                    padding: "1%",
                    lineHeight: "1.4",
                    fontSize: "95%",
                    color: Colors.rgba(185, 149, 93),
                    border: "none",
                    fontWeight: "600"
                  }
                }
              }
            }
          };
        }
      });
    }
  };
});
//# sourceMappingURL=AtomCalendarStyle.js.map