System.register(["tslib", "@web-atoms/core/dist/view-model/AtomViewModel", "@web-atoms/date-time/dist/DateTime"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, AtomViewModel, Watch, DateTime, CalendarViewModel;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistViewModelAtomViewModel) {
      AtomViewModel = _webAtomsCoreDistViewModelAtomViewModel.AtomViewModel;
      Watch = _webAtomsCoreDistViewModelAtomViewModel.Watch;
    }, function (_webAtomsDateTimeDistDateTime) {
      DateTime = _webAtomsDateTimeDistDateTime.default;
    }],
    execute: function () {
      _export("default", CalendarViewModel = class CalendarViewModel extends AtomViewModel {
        constructor() {
          super(...arguments);
          this.mStart = DateTime.today;
        }
        get year() {
          return this.start.year;
        }
        set year(v) {
          if (this.start.year === v) {
            return;
          }
          const s = this.mStart;
          this.mStart = new DateTime(v, s.month, s.day);
          this.refresh("start");
        }
        get month() {
          return this.start.month;
        }
        set month(v) {
          if (this.start.month === v) {
            return;
          }
          const s = this.mStart;
          this.mStart = new DateTime(s.year, v, s.day);
          this.refresh("start");
        }
        get start() {
          return this.mStart;
        }
        set start(value) {
          this.mStart = value;
          this.refresh("year");
          this.refresh("month");
        }
        get selectedDate() {
          return this.owner.selectedDate;
        }
        get enableFunc() {
          return this.owner.enableFunc;
        }
        get yearList() {
          const start = this.year + this.owner.yearStart;
          const end = this.year + this.owner.yearEnd;
          const a = [];
          for (let index = start; index <= end; index++) {
            a.push({
              label: index + "",
              value: index
            });
          }
          return a;
        }
        get items() {
          const today = DateTime.today;
          const start = this.start;
          let startDate = new DateTime(start.year, start.month, 1);
          while (startDate.dayOfWeek !== 1) {
            startDate = startDate.add(-1);
          }
          const a = [];
          const y = startDate.year;
          const m = startDate.month;
          for (let index = 0; index < 42; index++) {
            const cd = startDate.add(index);
            a.push({
              label: cd.day + "",
              type: null,
              value: cd,
              isToday: cd.equals(today),
              isOtherMonth: start.month !== cd.month,
              isWeekend: cd.dayOfWeek === 0 || cd.dayOfWeek === 6
            });
          }
          const o = this.owner;
          o.element.dispatchEvent(new CustomEvent("refresh", {
            detail: {
              year: start.year,
              month: start.month
            }
          }));
          o.currentDate = startDate;
          return a;
        }
        changeMonth(step) {
          const s = this.start.addMonths(step);
          const start = this.year + this.owner.yearStart;
          const end = this.year + this.owner.yearEnd;
          const sy = s.year;
          if (sy < start || sy > end) {
            return;
          }
          this.start = s;
          this.refresh("start");
        }
        dateClicked(item) {
          const e = this.owner.element;
          this.owner.selectedDate = item.value;
          e.dispatchEvent(new CustomEvent("dateClicked", {
            detail: item
          }));
        }
      });
      __decorate([Watch, __metadata("design:type", Object), __metadata("design:paramtypes", [])], CalendarViewModel.prototype, "selectedDate", null);
      __decorate([Watch, __metadata("design:type", Object), __metadata("design:paramtypes", [])], CalendarViewModel.prototype, "enableFunc", null);
      __decorate([Watch, __metadata("design:type", Array), __metadata("design:paramtypes", [])], CalendarViewModel.prototype, "yearList", null);
      __decorate([Watch, __metadata("design:type", Array), __metadata("design:paramtypes", [])], CalendarViewModel.prototype, "items", null);
    }
  };
});
//# sourceMappingURL=CalendarViewModel.js.map