System.register(["@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/XNode", "../buttons/AtomPopupButton", "../calendar/AtomCalendar", "../calendar/res/SRCalendar"], function (_export, _context) {
  "use strict";

  var Bind, XNode, AtomPopupButton, AtomCalendar, SRCalendar, AtomDateField, shortDate;
  return {
    setters: [function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_buttonsAtomPopupButton) {
      AtomPopupButton = _buttonsAtomPopupButton.default;
    }, function (_calendarAtomCalendar) {
      AtomCalendar = _calendarAtomCalendar.default;
    }, function (_calendarResSRCalendar) {
      SRCalendar = _calendarResSRCalendar.default;
    }],
    execute: function () {
      shortDate = {
        year: "numeric",
        month: "short",
        day: "numeric"
      };
      AtomDateField = class AtomDateField extends AtomPopupButton {
        create() {
          const srCalendar = this.app.resolve(SRCalendar);
          this.selectedDate = null;
          this.yearStart = -10;
          this.yearEnd = 10;
          this.enableFunc = null;
          this.labelFunc = null;
          this.locale = "en-US";
          this.localeOptions = shortDate;
          this.placeholder = "Select Date";
          this.render(XNode.create("div", {
            text: Bind.oneWay(() => this.selectedDate ? this.labelFunc ? this.labelFunc(this.selectedDate) : this.selectedDate.toLocaleDateString ? this.selectedDate.toLocaleDateString(this.locale, this.localeOptions) : srCalendar.toShortDate(this.selectedDate) : this.placeholder),
            eventResult: Bind.event((s, e) => this.selectedDate = e.detail)
          }, XNode.create(AtomPopupButton.page, null, XNode.create(AtomCalendar, {
            selectedDate: Bind.twoWays(() => this.selectedDate),
            yearStart: Bind.oneWay(() => this.yearStart),
            yearEnd: Bind.oneWay(() => this.yearEnd),
            enableFunc: Bind.oneWay(() => this.enableFunc),
            itemTemplate: Bind.oneWay(() => this.itemTemplate || undefined),
            eventDateClicked: Bind.event((s, e) => s.viewModel.close(e.detail.value))
          }))));
        }
        preCreate() {
          super.preCreate();
          this.selectedDate = null;
          this.yearStart = null;
          this.yearEnd = null;
          this.enableFunc = null;
          this.currentMonth = null;
          this.itemTemplate = null;
        }
      };
      AtomDateField.itemTemplate = XNode.prepare("itemTemplate", true, true);
      _export("default", AtomDateField);
    }
  };
});
//# sourceMappingURL=AtomDateField.js.map