System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/core/AtomUI", "../mobile-app/MobileApp", "../styles/desktop-app.global.css", "@web-atoms/core/dist/view-model/Action"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, BindableProperty, XNode, AtomControl, ChildEnumerator, MobileApp, Action, DesktopApp;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebCoreAtomUI) {
      ChildEnumerator = _webAtomsCoreDistWebCoreAtomUI.ChildEnumerator;
    }, function (_mobileAppMobileApp) {
      MobileApp = _mobileAppMobileApp.default;
    }, function (_stylesDesktopAppGlobalCss) {}, function (_webAtomsCoreDistViewModelAction) {
      Action = _webAtomsCoreDistViewModelAction.default;
    }],
    execute: function () {
      _export("default", DesktopApp = class DesktopApp extends AtomControl {
        onPropertyChanged(name) {
          super.onPropertyChanged(name);
          if (!this.initialized) {
            return;
          }
          switch (name) {
            case "statusBarRenderer":
              this.recreate(name, "status-bar");
              break;
            case "menuRenderer":
              this.recreate(name, "menu-renderer");
              break;
            case "sideBarRenderer":
              this.recreate(name, "side-bar");
              break;
          }
        }
        init() {}
        recreate(renderer, name, remove = true) {
          var _a, _b, _c;
          const node = (_b = (_a = this[renderer]) === null || _a === void 0 ? void 0 : _a.call(this)) !== null && _b !== void 0 ? _b : undefined;
          if (remove) {
            for (const e of ChildEnumerator.enumerate(this.element)) {
              if (e.dataset.pageElement === name) {
                this.dispose(e);
                e.remove();
                break;
              }
            }
          }
          if (node) {
            const na = (_c = node.attributes) !== null && _c !== void 0 ? _c : node.attributes = {};
            na["data-page-element"] = name;
            this.render(XNode.create("div", null, node));
            return this.element.querySelector(`[data-page-element="${name}"]`);
          }
          return null;
        }
        create() {
          this.render(XNode.create("div", {
            "data-desktop-app": "desktop-app"
          }, XNode.create(MobileApp, {
            "data-page-element": "app"
          })));
          this.recreate("menuRenderer", "menu-renderer", false);
          this.recreate("sideBarRenderer", "side-bar", false);
          this.recreate("statusBarRenderer", "status-bar", false);
          this.initialized = true;
          this.runAfterInit(() => {
            this.app.runAsync(() => this.init());
          });
        }
        onIconClick() {
          if (this.element.hasAttribute("drawer-hidden")) {
            this.element.removeAttribute("drawer-hidden");
          } else {
            this.element.setAttribute("drawer-hidden", "1");
          }
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Function)], DesktopApp.prototype, "menuRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DesktopApp.prototype, "sideBarRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], DesktopApp.prototype, "statusBarRenderer", void 0);
      __decorate([Action({
        onEvent: "iconClick"
      }), __metadata("design:type", Function), __metadata("design:paramtypes", []), __metadata("design:returntype", void 0)], DesktopApp.prototype, "onIconClick", null);
    }
  };
});
//# sourceMappingURL=DesktopApp.js.map