System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/services/http/RestService", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/core/InjectProperty", "@web-atoms/data-styles/data-styles", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/view-model/Action", "@web-atoms/core/dist/di/DISingleton", "../basic/AtomRepeater", "../basic/ToggleButtonBar", "./Devhost.global.css"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, __param, Bind, XNode, BaseService, Get, Query, AtomControl, InjectProperty, CancelToken, Action, DISingleton, AtomRepeater, ToggleButtonBar, AppHost, css, fileTypes, designModes, replaceSrc, toAbsoluteUrl, FileService;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
      __param = _tslib.__param;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistServicesHttpRestService) {
      BaseService = _webAtomsCoreDistServicesHttpRestService.BaseService;
      Get = _webAtomsCoreDistServicesHttpRestService.Get;
      Query = _webAtomsCoreDistServicesHttpRestService.Query;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistCoreInjectProperty) {
      InjectProperty = _webAtomsCoreDistCoreInjectProperty.default;
    }, function (_webAtomsDataStylesDataStyles) {}, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistViewModelAction) {
      Action = _webAtomsCoreDistViewModelAction.default;
    }, function (_webAtomsCoreDistDiDISingleton) {
      DISingleton = _webAtomsCoreDistDiDISingleton.default;
    }, function (_basicAtomRepeater) {
      AtomRepeater = _basicAtomRepeater.default;
    }, function (_basicToggleButtonBar) {
      ToggleButtonBar = _basicToggleButtonBar.default;
    }, function (_DevhostGlobalCss) {}],
    execute: function () {
      css = "dev-host-local";
      fileTypes = () => [{
        label: "Packed",
        value: "packed"
      }, {
        label: "All",
        value: "all"
      }];
      designModes = () => [{
        label: "Design",
        value: true
      }, {
        label: "Live",
        value: false
      }];
      replaceSrc = src => {
        src = src.split("\\").join("/");
        const tokens = src.split("/");
        if (tokens[0] === "src") {
          tokens[0] = "dist";
        }
        return tokens.join("/");
      };
      toAbsoluteUrl = (file, designMode) => {
        let url = `/_view/${replaceSrc(file.dir)}/${file.name}`;
        if (designMode) {
          if (url.indexOf("?") === -1) {
            url += "?";
          }
          url += "&designMode=true";
        }
        return `${location.protocol}//${location.host}${url}`;
      };
      _export("FileService", FileService = class FileService extends BaseService {
        getModules(search, packed, cancelToken) {
          return __awaiter(this, void 0, void 0, function* () {
            const result = yield this.getRemoteModules(search, packed, cancelToken);
            return result.files;
          });
        }
        getRemoteModules(search, packed, ct) {
          return null;
        }
      });
      __decorate([Get("/flat-modules"), __param(0, Query("search")), __param(1, Query("packed")), __metadata("design:type", Function), __metadata("design:paramtypes", [String, Boolean, CancelToken]), __metadata("design:returntype", Promise)], FileService.prototype, "getRemoteModules", null);
      _export("FileService", FileService = __decorate([DISingleton({})], FileService));
      _export("default", AppHost = class AppHost extends AtomControl {
        constructor() {
          super(...arguments);
          this.search = "";
          this.designMode = false;
          this.fileType = "packed";
        }
        init() {
          return __awaiter(this, void 0, void 0, function* () {
            this.render(XNode.create("div", {
              class: css
            }, XNode.create("header", {
              "data-layout": "row",
              "data-padding": "auto",
              class: "header"
            }, XNode.create("input", {
              type: "search",
              value: Bind.twoWaysImmediate(() => this.search),
              placeholder: "Search..."
            }), XNode.create("span", null, "Mode"), XNode.create(ToggleButtonBar, {
              items: designModes(),
              value: Bind.twoWays(() => this.designMode)
            }), XNode.create(ToggleButtonBar, {
              items: fileTypes(),
              value: Bind.twoWays(() => this.fileType)
            })), XNode.create("div", null, XNode.create(AtomRepeater, {
              class: "grid",
              items: Bind.oneWayAsync((x, e, cancelToken) => this.getModules(this.search, this.fileType === "packed", cancelToken)),
              for: "table",
              itemRenderer: item => XNode.create("tr", {
                template: "itemTemplate"
              }, XNode.create("td", null, XNode.create("div", {
                text: item.name,
                title: item.dir,
                style: "font-weight: 500;"
              }), XNode.create("div", {
                style: "font-size: small;",
                text: item.dir
              })), XNode.create("td", null, XNode.create("a", {
                "data-layout": "accent-button",
                "data-text-decoration": "none",
                href: Bind.source(item, x => toAbsoluteUrl(x.source, this.designMode)),
                target: "_blank",
                text: "Open"
              }), XNode.create("i", {
                class: "fas fa-copy",
                title: "Copy Url",
                style: "margin: 5px; cursor: pointer;",
                "data-click-event": "copy-url",
                eventClick: () => this.copyUrl(toAbsoluteUrl(item, this.designMode))
              })))
            }))));
          });
        }
        getModules(search, packed, cancelToken) {
          return __awaiter(this, void 0, void 0, function* () {
            const result = yield this.fileService.getModules(search, packed, cancelToken);
            if (!result.length && packed) {
              this.fileType = "all";
            }
            return result;
          });
        }
        preCreate() {
          super.preCreate();
          this.app.installStyleSheet({
            href: "https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free@6.4.0/css/all.min.css",
            integrity: "sha256-HtsXJanqjKTc8vVQjO4YMhiqFoXkfBsjBWcX91T1jr8=",
            crossOrigin: "anonymous"
          });
          this.runAfterInit(() => this.app.runAsync(() => this.init()));
        }
        copyUrl(url) {
          return __awaiter(this, void 0, void 0, function* () {
            yield navigator.clipboard.writeText(url);
          });
        }
      });
      __decorate([InjectProperty, __metadata("design:type", FileService)], AppHost.prototype, "fileService", void 0);
      __decorate([Action({
        success: "Copied successfully"
      }), __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", Promise)], AppHost.prototype, "copyUrl", null);
    }
  };
});
//# sourceMappingURL=DevHost.js.map