System.register(["tslib", "@web-atoms/core/dist/core/AtomBinder", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/services/NavigationService", "@web-atoms/core/dist/web/controls/AtomControl", "./HelpPopup"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, AtomBinder, Bind, BindableProperty, XNode, NavigationService, AtomControl, AtomField, inputID;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreAtomBinder) {
      AtomBinder = _webAtomsCoreDistCoreAtomBinder.AtomBinder;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistServicesNavigationService) {
      NavigationService = _webAtomsCoreDistServicesNavigationService.NavigationService;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_HelpPopup) {
      _export("HP", _HelpPopup.default);
    }],
    execute: function () {
      inputID = 0;
      _export("default", AtomField = class AtomField extends AtomControl {
        get hasError() {
          return this.error ? true : false;
        }
        get hasHelp() {
          return this.helpText || this.helpLink ? true : false;
        }
        onPropertyChanged(name) {
          switch (name) {
            case "helpLink":
            case "helpText":
              AtomBinder.refreshValue(this, "hasHelp");
              break;
          }
        }
        openHelp() {
          return __awaiter(this, void 0, void 0, function* () {
            const n = this.app.resolve(NavigationService);
            if (this.helpText) {
              yield n.openPage("@web-atoms/web-controls/dist/form/HelpPopup", {
                message: this.helpText
              });
              return;
            }
            if (this.helpLink) {
              yield n.openPage(this.helpLink);
            }
          });
        }
        preCreate() {
          this.label = null;
          this.error = null;
          this.helpText = null;
          this.helpLink = null;
          this.helpIcon = null;
          this.required = false;
          this.visible = true;
          this.fieldClass = "";
        }
        render(node, e, creator) {
          this.render = super.render;
          super.render(XNode.create("div", Object.assign({}, node.attributes, {
            class: Bind.oneWay(() => ({
              "form-field": 1,
              [this.fieldClass]: this.fieldClass,
              "has-error": this.error,
              "field-hidden": !this.visible
            }))
          }), XNode.create("label", {
            class: "label",
            text: Bind.oneWay(() => this.label),
            htmlFor: Bind.oneWay(() => this.htmlFor)
          }), XNode.create("span", {
            class: "required",
            styleVisibility: Bind.oneTime(() => this.required ? "visible" : "hidden")
          }, "*"), XNode.create("div", {
            class: "presenter"
          }, ...node.children), XNode.create("span", {
            class: "error",
            styleDisplay: Bind.oneWay(() => this.error ? "" : "none"),
            text: Bind.oneWay(() => this.error)
          })));
          const first = this.element.getElementsByTagName("input")[0];
          if (first) {
            if (!first.id) {
              first.id = `webAtomsFormFieldInputNumber${inputID++}`;
            }
            this.htmlFor = first.id;
          }
        }
      });
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "icon", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "label", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "error", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "helpText", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "helpLink", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "helpIcon", void 0);
      __decorate([BindableProperty, __metadata("design:type", Boolean)], AtomField.prototype, "required", void 0);
      __decorate([BindableProperty, __metadata("design:type", Boolean)], AtomField.prototype, "visible", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomField.prototype, "fieldClass", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomField.prototype, "contentPresenter", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomField.prototype, "htmlFor", void 0);
    }
  };
});
//# sourceMappingURL=AtomField.js.map