import XNode from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
export { default as Toolbar } from "./commands/Toolbar";
import "../styles/atom-html-editor.global.css";
export interface IEditorCommand {
    target: HTMLElement;
    command: string;
    commandParameter: string;
}
export interface ITagCommand<T = any> {
    name: string;
    style: any;
    handler: (ce: CustomEvent<{
        target: HTMLElement;
        data: T;
    }>) => any;
}
export default class AtomHtmlEditor extends AtomControl {
    content: string;
    header: any[];
    version: number;
    files: File[];
    editor: HTMLDivElement;
    tags: ITagCommand[];
    eventDocumentCreated: (e: CustomEvent<HTMLDivElement>) => void;
    eventDocumentUpdated: (e: CustomEvent<HTMLDivElement>) => void;
    eventCommand: (e: CustomEvent<IEditorCommand>) => void;
    get htmlContent(): string;
    set htmlContent(v: string);
    private editorWindow;
    private editorDocument;
    private initialContent;
    insertImage(s: AtomHtmlEditor, e: Event): string | Promise<string>;
    executeCommand(cmd: any, showUI?: boolean, value?: string): boolean;
    queryCommandState(cmd: string, ...a: any[]): boolean;
    getStyle(name: string, v: any): string;
    onPropertyChanged(name: any): void;
    protected setupTags(): void;
    protected preCreate(): void;
    protected onPasteEvent(e: ClipboardEvent): void;
    protected onInputEvent(e: InputEvent): void;
    protected setup(): void;
    protected documentCreated(e: HTMLDivElement): void;
    protected documentUpdated(e: HTMLDivElement): void;
    protected render(node: XNode, e?: any, creator?: any): void;
}
//# sourceMappingURL=AtomHtmlEditor.d.ts.map