System.register(["tslib", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/core/sleep", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/core/AtomUI", "@web-atoms/data-styles/data-styles", "./commands/AddImage", "../styles/inline-html-editor.global.css"], function (_export, _context) {
  "use strict";

  var __awaiter, XNode, sleep, CancelToken, AtomControl, ChildEnumerator, descendentElementIterator, showImageDialog, InlineHtmlEditor;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistCoreSleep) {
      sleep = _webAtomsCoreDistCoreSleep.default;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebCoreAtomUI) {
      ChildEnumerator = _webAtomsCoreDistWebCoreAtomUI.ChildEnumerator;
      descendentElementIterator = _webAtomsCoreDistWebCoreAtomUI.descendentElementIterator;
    }, function (_webAtomsDataStylesDataStyles) {}, function (_commandsAddImage) {
      showImageDialog = _commandsAddImage.showImageDialog;
    }, function (_stylesInlineHtmlEditorGlobalCss) {}],
    execute: function () {
      _export("default", InlineHtmlEditor = class InlineHtmlEditor extends AtomControl {
        constructor() {
          super(...arguments);
          this.undoLimit = 100;
          this.editableSelector = ".editable";
        }
        get htmlContent() {
          return this.htmlTextContent.html;
        }
        set htmlContent(v) {
          this.content = v;
        }
        get htmlTextContent() {
          var _a;
          const copy = document.createElement("div");
          copy.innerHTML = this.editor.innerHTML;
          for (const node of descendentElementIterator(copy)) {
            node.removeAttribute("contenteditable");
          }
          (_a = this.sanitizeHtml) === null || _a === void 0 ? void 0 : _a.call(this, copy);
          return {
            html: copy.innerHTML,
            text: copy.innerText
          };
        }
        get content() {
          return this.editor.innerHTML;
        }
        set content(value) {
          this.editor.innerHTML = value;
          setTimeout(() => this.onContentSet(), 100);
        }
        set toolbar(v) {
          this.dispose(this.toolbarElement);
          this.toolbarElement.innerHTML = "";
          this.render(v(), this.toolbarElement, this);
        }
        executeCommand(command, showUI, value) {
          var _a;
          const selection = window.getSelection();
          selection.removeAllRanges();
          if (!this.selection) {
            const range = document.createRange();
            const start = (_a = ChildEnumerator.find(this.editor, x => x.isContentEditable)) !== null && _a !== void 0 ? _a : this.editor.firstElementChild;
            range.setEndAfter(start.lastChild);
            range.setStartAfter(start.lastChild);
            selection.addRange(range);
          } else {
            selection.addRange(this.selection);
          }
          return document.execCommand(command, showUI, value);
        }
        getStyle(name) {
          const selection = this.selection;
          if (!selection) {
            return void 0;
          }
          const node = selection;
          const e = node.startContainer.parentElement;
          return window.getComputedStyle(e)[name];
        }
        queryCommandState(command) {
          return document.queryCommandState(command);
        }
        onContentSet() {
          var _a;
          const start = (_a = Array.from(this.editor.querySelectorAll(this.editableSelector))[0]) !== null && _a !== void 0 ? _a : this.editor.firstElementChild;
          if (start) {
            start.contentEditable = "true";
          }
          this.editor.dispatchEvent(new CustomEvent("contentReady", {
            detail: this.editor.innerHTML,
            bubbles: true
          }));
        }
        saveSelection() {
          const selection = window.getSelection();
          this.selection = selection.rangeCount === 0 ? null : selection.getRangeAt(0);
        }
        insertImage(s, e) {
          return showImageDialog(s, e);
        }
        preCreate() {
          this.version = 1;
          this.element.setAttribute("data-inline-editor", "inline-editor");
          this.render(XNode.create("div", null, XNode.create("div", {
            "data-element": "toolbar"
          }), XNode.create("div", {
            "data-element": "editor"
          })));
          this.editor = this.element.querySelector(`[data-element=editor]`);
          this.toolbarElement = this.element.querySelector(`[data-element=toolbar]`);
          this.bindEvent(this.editor, "blur", () => this.saveSelection(), void 0, true);
          this.bindEvent(this.editor, "input", e => this.onContentInput(e));
          this.bindEvent(this.editor, "keydown", e => this.updateQueryCommand());
          this.bindEvent(this.editor, "click", e => this.updateQueryCommand(e));
          this.bindEvent(this.editor, "paste", e => this.onPasteEvent(e));
          this.bindEvent(this.editor, "cut", () => this.onContentInput());
          this.bindEvent(this.editor, "drop", e => this.onDrop(e));
        }
        updateQueryCommand(e) {
          if ((e === null || e === void 0 ? void 0 : e.type) === "click") {
            if (!this.editor.textContent) {
              let first = this.editor.firstElementChild;
              if (!first) {
                first = document.createElement("div");
                first.innerHTML = "<p><br/></p>";
                this.editor.appendChild(first);
              } else {
                if (!first.lastChild) {
                  first.innerHTML = "<p></br></b>";
                }
              }
            }
          }
          this.version++;
        }
        onDrop(e) {
          e.preventDefault();
          const text = e.dataTransfer.getData("text/plain");
          if (!text) {
            return;
          }
          let last = null;
          for (const node of descendentElementIterator(this.element)) {
            if (node.isContentEditable) {
              last = node;
              continue;
            }
          }
          if (last) {
            last.appendChild(document.createTextNode(text));
          }
        }
        onPasteEvent(e) {
          if (!e.clipboardData.types.find(x => x === "text/html")) {
            this.onContentInput();
            return;
          }
          const d = e.clipboardData.getData("text/plain");
          if (d) {
            const s = window.getSelection();
            const r = s.getRangeAt(0);
            let last;
            const tags = [];
            for (const iterator of d.split("\n")) {
              const text = iterator.trim();
              if (!text) {
                continue;
              }
              last = document.createElement("p");
              last.innerText = iterator;
              tags.push(last);
            }
            while (tags.length) {
              r.insertNode(tags.pop());
            }
            r.setStartAfter(last);
            this.onContentInput();
          }
          e.preventDefault();
        }
        contentModified() {
          this.element.dispatchEvent(new CustomEvent("contentChanged", {
            detail: this.editor.innerHTML,
            bubbles: true
          }));
        }
        onContentInput(e) {
          var _a;
          (_a = this.token) === null || _a === void 0 ? void 0 : _a.cancel();
          const token = this.token = new CancelToken();
          this.app.runAsync(() => __awaiter(this, void 0, void 0, function* () {
            yield sleep(500, token, false);
            if (token.cancelled) {
              return;
            }
            this.contentModified();
          }));
        }
      });
    }
  };
});
//# sourceMappingURL=InlineHtmlEditor.js.map