System.register(["tslib", "@web-atoms/core/dist/core/XNode", "../../basic/UploadEvent", "@web-atoms/core/dist/web/controls/AtomControl"], function (_export, _context) {
  "use strict";

  var __awaiter, XNode, UploadEvent, AtomControl, onAttachImage;
  function AttachImage({
    accept = "image/*",
    maxSize = 1024 * 1024 * 5,
    authorize = true,
    capture = null,
    ariaLabel = "upload"
  }) {
    return XNode.create("button", Object.assign({
      title: "Insert Image",
      class: "command"
    }, UploadEvent.AttachUploadAction({
      accept,
      forceType: true,
      maxSize,
      authorize,
      capture,
      multiple: false,
      ariaLabel,
      "event-files-available": onAttachImage
    })), XNode.create("i", {
      class: "ri-image-add-fill"
    }));
  }
  _export("default", AttachImage);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_basicUploadEvent) {
      UploadEvent = _basicUploadEvent.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }],
    execute: function () {
      onAttachImage = ce => __awaiter(void 0, void 0, void 0, function* () {
        var _a, _b;
        const c = AtomControl.from(ce.target);
        if (!((_b = (_a = ce.detail) === null || _a === void 0 ? void 0 : _a.files) === null || _b === void 0 ? void 0 : _b.length)) {
          return;
        }
        const file = ce.detail.files[0];
        const fr = new FileReader();
        fr.onload = () => {
          c.executeCommand("insertHTML", void 0, `<div><img data-content="data-url" src="${fr.result}" style='max-height: 700px;'/></div>`);
        };
        fr.readAsDataURL(file);
      });
    }
  };
});
//# sourceMappingURL=AttachImage.js.map