import { CancelToken } from "@web-atoms/core/dist/core/types";
import XNode from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
import { IPopupOptions } from "@web-atoms/core/dist/web/services/PopupService";
export * as zDoNotUse from "../animations/Animations";
import "./bottom-popup.global.css";
export interface IBottomPopupOptions extends IPopupOptions {
    parameters?: {
        [key: string]: any;
    };
}
export default class BottomPopup extends AtomControl {
    static showModal<T>(options: IBottomPopupOptions): Promise<T>;
    static show<T>({ parameters, cancelToken }?: IBottomPopupOptions): Promise<T>;
    parameters: any;
    modal: boolean;
    close: (r?: any) => void;
    cancel: (reason?: any) => void;
    titleRenderer: () => XNode;
    headerRenderer: () => XNode;
    closeRenderer: () => XNode;
    footerRenderer: () => XNode;
    barRenderer: () => XNode;
    /**
     * This will be set to cancelled when popup is closed.
     * You can override cancelRequested method to intercept cancellation.
     */
    popupCancelToken: CancelToken;
    private animate;
    dispose(e?: HTMLElement): void;
    init(): Promise<void>;
    protected preCreate(): void;
    protected render(node: XNode, e?: any, creator?: any): void;
    protected cancelRequested(): void;
    protected updateElement(name: string, property?: string): void;
}
//# sourceMappingURL=BottomPopup.d.ts.map