System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/types", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/core/AtomUI", "@web-atoms/core/dist/web/services/PopupService", "../animations/Animations", "./MobileApp", "./bottom-popup.global.css"], function (_export, _context) {
  "use strict";

  var __awaiter, __decorate, __metadata, BindableProperty, CancelToken, XNode, AtomControl, ChildEnumerator, PopupService, MobileApp, BottomPopup;
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __awaiter = _tslib.__awaiter;
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreTypes) {
      CancelToken = _webAtomsCoreDistCoreTypes.CancelToken;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebCoreAtomUI) {
      ChildEnumerator = _webAtomsCoreDistWebCoreAtomUI.ChildEnumerator;
    }, function (_webAtomsCoreDistWebServicesPopupService) {
      PopupService = _webAtomsCoreDistWebServicesPopupService.default;
    }, function (_animationsAnimations) {
      _export({});
    }, function (_MobileApp) {
      MobileApp = _MobileApp.default;
    }, function (_bottomPopupGlobalCss) {}],
    execute: function () {
      _export("default", BottomPopup = class BottomPopup extends AtomControl {
        static showModal(options) {
          return this.show(options);
        }
        static show() {
          return __awaiter(this, arguments, void 0, function* ({
            parameters,
            cancelToken
          } = {}) {
            var _a;
            const last = PopupService.lastTarget;
            const current = MobileApp.current;
            const popup = new this(current.app);
            popup.parameters = parameters;
            popup.bindEvent(window, "backButton", ce => {
              ce.preventDefault();
              return popup.cancelRequested();
            }, void 0, true);
            popup.bindEvent(popup.element, "cancelPopup", () => popup.cancelRequested());
            if (popup.modal) {
              const container = document.createElement("div");
              container.setAttribute("data-bottom-popup-container", "1");
              popup.bindEvent(container, "click", e => {
                if (e.target === e.currentTarget) {
                  e.preventDefault();
                  e.stopImmediatePropagation();
                  e.stopPropagation();
                  popup.element.dispatchEvent(new CustomEvent("cancelPopup"));
                }
              });
              popup.registerDisposable({
                dispose: () => {
                  container.remove();
                }
              });
              container.append(popup.element);
              current.element.append(container);
            } else {
              current.element.append(popup.element);
            }
            if (cancelToken) {
              cancelToken.registerForCancel(popup.cancel);
            }
            const result = new Promise((resolve, reject) => {
              let disposed = false;
              popup.close = r => {
                if (disposed) {
                  return;
                }
                disposed = true;
                popup.dispose();
                resolve(r);
                PopupService.lastTarget = last;
              };
              popup.cancel = (reason = "cancelled") => {
                if (disposed) {
                  return;
                }
                disposed = true;
                popup.dispose();
                reject(reason);
                PopupService.lastTarget = last;
              };
            });
            const pr = (_a = popup.init) === null || _a === void 0 ? void 0 : _a.call(popup);
            if (pr) {
              try {
                yield pr;
              } catch (e) {
                popup.cancel(e);
              }
            }
            return yield result;
          });
        }
        dispose(e) {
          if (e) {
            super.dispose(e);
            return;
          }
          const element = this.element;
          this.element.setAttribute("data-animation-state", "down");
          setTimeout(() => {
            super.dispose(e);
            element.remove();
          }, 500);
        }
        init() {
          return __awaiter(this, void 0, void 0, function* () {});
        }
        preCreate() {
          this.modal = true;
          const element = this.element;
          element.dataset.bottomPopup = "bottom-popup";
          this.animate = true;
          super.preCreate();
          this.barRenderer = () => XNode.create("div", null);
          this.popupCancelToken = new CancelToken();
          this.registerDisposable({
            dispose: () => {
              this.popupCancelToken.cancel();
            }
          });
          this.bindEvent(this.element, "closeClick", () => this.cancelRequested());
        }
        render(node, e, creator) {
          var _a, _b;
          this.render = super.render;
          const na = (_a = node.attributes) !== null && _a !== void 0 ? _a : node.attributes = {};
          na["data-element"] = "content";
          (_b = na["data-click-event"]) !== null && _b !== void 0 ? _b : na["data-click-event"] = "popupClick";
          this.render(XNode.create("div", null, node));
          this.updateElement("title");
          this.updateElement("bar");
          this.updateElement("icon");
          this.updateElement("close");
          this.updateElement("footer");
          if (!this.animate) {
            return;
          }
          this.element.setAttribute("data-animate-slide", this.animate ? "from-bottom" : "normal");
          this.element.setAttribute("data-animation-state", "down");
          this.animate = false;
          setTimeout(() => {
            this.element.setAttribute("data-animation-state", "normal");
          }, 10);
        }
        cancelRequested() {
          return this.cancel();
        }
        updateElement(name, property = name + "Renderer") {
          var _a, _b;
          const r = this[property];
          const child = ChildEnumerator.find(this.element, e => e.dataset.element === name);
          if (child) {
            this.dispose(child);
            child.remove();
          }
          const node = r === null || r === void 0 ? void 0 : r();
          if (!node) {
            return;
          }
          const na = (_a = node.attributes) !== null && _a !== void 0 ? _a : node.attributes = {};
          na["data-element"] = name;
          (_b = na["data-click-event"]) !== null && _b !== void 0 ? _b : na["data-click-event"] = name + "-click";
          this.render(XNode.create("div", null, node));
        }
      });
      __decorate([BindableProperty, __metadata("design:type", Function)], BottomPopup.prototype, "titleRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], BottomPopup.prototype, "headerRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], BottomPopup.prototype, "closeRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], BottomPopup.prototype, "footerRenderer", void 0);
      __decorate([BindableProperty, __metadata("design:type", Function)], BottomPopup.prototype, "barRenderer", void 0);
      delete BottomPopup.prototype.init;
    }
  };
});
//# sourceMappingURL=BottomPopup.js.map