import { AtomUri } from "@web-atoms/core/dist/core/AtomUri";
import XNode from "@web-atoms/core/dist/core/XNode";
import { AtomControl } from "@web-atoms/core/dist/web/controls/AtomControl";
import { IDialogOptions } from "@web-atoms/core/dist/web/services/PopupService";
import { CancelToken } from "@web-atoms/core/dist/core/types";
import "./MobileApp.global.css";
export declare function PullToRefresh(): any;
export declare class Drawer extends AtomControl {
    protected init(): any;
    protected preCreate(): void;
    protected closeDrawer(): void;
}
export declare class BasePage extends AtomControl {
    close: (result: any) => void;
    cancel: (error?: any) => void;
    closeWarning: string;
    title?: string;
    titleRenderer: () => XNode;
    iconRenderer: () => XNode;
    actionRenderer: () => XNode;
    footerRenderer: () => XNode;
    actionBarRenderer: () => XNode;
    headerRenderer: () => XNode;
    pullToRefreshRenderer: () => XNode;
    iconClass: any;
    keep: boolean;
    /**
     * If set to true, you must set `autofocus` attribute
     * to enable focus when page is visible.
     */
    disableAutoFocus: boolean;
    get route(): string;
    set route(url: string);
    private routeUrl;
    private routeDisposable;
    private viewModelTitle;
    private initialized;
    private contentElement;
    private pullToRefreshElement;
    private pullToRefreshDisposable;
    private scrollTop;
    get hideToolbar(): boolean;
    set hideToolbar(v: boolean);
    protected readonly cancelToken: CancelToken;
    requestCancel(): Promise<void>;
    onPropertyChanged(name: any): void;
    protected init(): any;
    /**
     * This is because if someone changes renderer, entire content will
     * vanish, so we need to update allow update of only content element
     * @returns
     */
    protected rendererChanged(): void;
    protected recreate(renderer: any, name: any): HTMLElement;
    protected preCreate(): void;
    protected render(node: XNode, e?: any, creator?: any): void;
    protected enablePullToRefreshEvents(): HTMLElement;
    protected dispatchIconClickEvent(e: Event): void;
    protected hide(): void;
    protected show(): void;
}
export declare class ContentPage<T = any, TResult = any> extends BasePage {
    parameters: T;
    close: (result: TResult) => any;
}
export type InputOf<T extends ContentPage> = T extends ContentPage<infer T> ? T : any;
export type OutputOf<T extends ContentPage> = T extends ContentPage<any, infer T> ? T : any;
export declare class TabbedPage extends BasePage {
}
export default class MobileApp extends AtomControl {
    static current: MobileApp;
    static drawer: (attributes: Partial<unknown>, ...nodes: XNode[]) => XNode;
    static pushPage<T>(pageUri: string | any, parameters?: {
        [key: string]: any;
    }, clearHistory?: boolean): Promise<T>;
    drawer: typeof Drawer;
    hideDrawer: () => void;
    pages: BasePage[];
    selectedPage: BasePage;
    /**
     * Set this to class or url to load the page when user
     * hits back button when there is nothing in history stack
     */
    defaultPage: any;
    private container;
    popTo(w: any): void;
    back(): Promise<boolean>;
    protected init(): Promise<void>;
    protected preCreate(): void;
    protected loadPageForReturn(url: AtomUri, clearHistory: boolean): Promise<any>;
    protected loadPage(page: BasePage, clearHistory: boolean): Promise<unknown>;
}
export declare const isMobileView: any;
declare const PopupWindowPage_base: typeof ContentPage;
export declare class PopupWindowPage<TIn = any, TOut = any> extends PopupWindowPage_base {
    parameters: TIn;
    static dialogOptions: IDialogOptions;
    close: (r: TOut) => void;
    cancel: (error?: any) => void;
    title: string;
    headerRenderer: () => XNode;
    footerRenderer: () => XNode;
    titleRenderer: () => XNode;
}
export {};
//# sourceMappingURL=MobileApp.d.ts.map