System.register(["tslib", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomFrame", "./AtomPageFrameTemplate", "./PageFrameViewModel", "./TitleTemplate", "@web-atoms/core/dist/core/Hacks"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, BindableProperty, XNode, AtomFrame, AtomPageFrameTemplate, PageFrameViewModel, TitleTemplate, refreshInherited, AtomPageFrame;
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomFrame) {
      AtomFrame = _webAtomsCoreDistWebControlsAtomFrame.AtomFrame;
    }, function (_AtomPageFrameTemplate) {
      AtomPageFrameTemplate = _AtomPageFrameTemplate.default;
    }, function (_PageFrameViewModel) {
      PageFrameViewModel = _PageFrameViewModel.default;
    }, function (_TitleTemplate) {
      TitleTemplate = _TitleTemplate.default;
    }, function (_webAtomsCoreDistCoreHacks) {
      refreshInherited = _webAtomsCoreDistCoreHacks.refreshInherited;
    }],
    execute: function () {
      AtomPageFrame = class AtomPageFrame extends AtomFrame {
        constructor() {
          super(...arguments);
          this.created = false;
        }
        preCreate() {
          super.preCreate();
          this.menuUrl = null;
          this.tabsTemplate = null;
          this.frameTemplate = AtomPageFrameTemplate;
          this.titleTemplate = TitleTemplate;
          this.created = false;
          this.previousCommands = null;
          this.previousTabs = null;
          this.name = "root";
          this.runAfterInit(() => {
            this.saveScrollPosition = true;
          });
          this.localViewModel = this.resolve(PageFrameViewModel, () => ({
            owner: this
          }));
        }
        clearStack() {
          for (const iterator of this.stack) {
            const e = iterator.page.element;
            iterator.page.dispose();
            e.remove();
          }
          this.stack.length = 0;
        }
        onUpdateUI() {
          if (this.created) {
            return;
          }
          this.frame = new this.frameTemplate(this.app);
          const title = new this.titleTemplate(this.app);
          this.frame.titlePresenter.appendChild(title.element);
          this.element.appendChild(this.frame.element);
          this.pagePresenter = this.frame.pagePresenter;
          this.tabsPresenter = this.frame.tabsPresenter;
          this.frame.bind(this.frame.element, "tabs", [["this", "previousTabs"]], false, null, this);
          this.created = true;
          this.attachTabs(this.tabs);
        }
        push(ctrl) {
          if (!this.frame) {
            setTimeout(() => {
              this.push(ctrl);
            }, 100);
            return;
          }
          ctrl.title = null;
          super.push(ctrl);
        }
        onPropertyChanged(name) {
          switch (name) {
            case "current":
              this.bindCommands(this.current);
              this.bindTabs(this.current);
              break;
            case "tabsTemplate":
              this.createTabs();
              break;
          }
        }
        pushUrl(url) {
          if (url === this.url) {
            return;
          }
          if (this.stack.length > 0) {
            const last = this.stack[this.stack.length - 1];
            if (last.url === url) {
              this.popStack();
              return;
            }
          }
          this.url = url;
        }
        createTabs() {
          if (!this.tabsTemplate) {
            this.tabs = null;
            this.disposeTabs();
            return;
          }
          this.tabs = new this.tabsTemplate(this.app);
          this.tabs.element._logicalParent = this.element;
          this.attachTabs(this.tabs);
        }
        setUrl(url) {
          super.setUrl(url);
          this.localViewModel.url = url;
        }
        disposeTabs() {
          if (!this.previousTabs) {
            return;
          }
          const e = this.previousTabs.element;
          this.previousTabs.dispose();
          if (e) {
            e.remove();
          }
          this.previousTabs = null;
        }
        bindTabs(v) {
          if (!this.frame) {
            return;
          }
          if (!this.tabsPresenter) {
            return;
          }
          if (this.previousTabs) {
            if (this.tabs !== this.previousTabs) {
              this.disposeTabs();
            }
          }
          if (!v.tabsTemplate) {
            if (this.tabs && this.tabs !== this.previousTabs) {
              this.attachTabs(this.tabs);
            }
            return;
          }
          const t = new v.tabsTemplate(this.app);
          t.element._logicalParent = v.element;
          this.attachTabs(t);
        }
        bindCommands(v) {
          if (!this.frame) {
            return;
          }
          if (!this.frame.commandPresenter) {
            return;
          }
          if (this.previousCommands) {
            const e = this.previousCommands.element;
            if (e) {
              this.previousCommands.dispose();
              e.remove();
            }
            this.previousCommands = null;
          }
          if (!v.commandTemplate) {
            return;
          }
          const c = new v.commandTemplate(this.app);
          this.previousCommands = c;
          c.element._logicalParent = v.element;
          this.frame.commandPresenter.appendChild(c.element);
        }
        attachTabs(t) {
          if (!t || !t.element) {
            return;
          }
          if (!this.tabsPresenter) {
            setTimeout(() => {
              this.attachTabs(t);
            }, 100);
            return;
          }
          this.tabsPresenter.innerHTML = "";
          this.tabsPresenter.append(t.element);
          this.previousTabs = t;
          refreshInherited(t, "data");
          refreshInherited(t, "viewModel");
          refreshInherited(t, "localViewModel");
        }
      };
      AtomPageFrame.frameTemplate = XNode.prepare("frameTemplate", true, true);
      AtomPageFrame.titleTemplate = XNode.prepare("titleTemplate", true, true);
      _export("default", AtomPageFrame);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomPageFrame.prototype, "menuUrl", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomPageFrame.prototype, "tabsTemplate", void 0);
    }
  };
});
//# sourceMappingURL=AtomPageFrame.js.map