System.register(["tslib", "@web-atoms/core/dist/core/Bind", "@web-atoms/core/dist/core/BindableProperty", "@web-atoms/core/dist/core/PropertyBinding", "@web-atoms/core/dist/core/XNode", "@web-atoms/core/dist/web/controls/AtomControl", "@web-atoms/core/dist/web/controls/AtomToggleButtonBar", "@web-atoms/date-time/dist/TimeSpan", "./AtomTimeFieldStyle"], function (_export, _context) {
  "use strict";

  var __decorate, __metadata, Bind, BindableProperty, PropertyBinding, XNode, AtomControl, AtomToggleButtonBar, TimeSpan, AtomTimeFieldStyle, AtomTimeField, zones;
  function toTimeString(ts) {
    const h = ts.zone === "AM" ? ts.hour : ts.hour + 12;
    const t = new TimeSpan(0, h, ts.minutes);
    return t.toString(true);
  }
  function fromTimeString(t, ti) {
    if (!t) {
      return ti;
    }
    const ts = TimeSpan.parse(t);
    const isMorning = ts.totalMinutes < 12 * 60;
    ti = ti || {};
    ti.hour = isMorning ? ts.hours : ts.hours - 12;
    ti.minutes = ts.minutes;
    ti.zone = isMorning ? "AM" : "PM";
    return ti;
  }
  _export("default", void 0);
  return {
    setters: [function (_tslib) {
      __decorate = _tslib.__decorate;
      __metadata = _tslib.__metadata;
    }, function (_webAtomsCoreDistCoreBind) {
      Bind = _webAtomsCoreDistCoreBind.default;
    }, function (_webAtomsCoreDistCoreBindableProperty) {
      BindableProperty = _webAtomsCoreDistCoreBindableProperty.BindableProperty;
    }, function (_webAtomsCoreDistCorePropertyBinding) {
      PropertyBinding = _webAtomsCoreDistCorePropertyBinding.PropertyBinding;
    }, function (_webAtomsCoreDistCoreXNode) {
      XNode = _webAtomsCoreDistCoreXNode.default;
    }, function (_webAtomsCoreDistWebControlsAtomControl) {
      AtomControl = _webAtomsCoreDistWebControlsAtomControl.AtomControl;
    }, function (_webAtomsCoreDistWebControlsAtomToggleButtonBar) {
      AtomToggleButtonBar = _webAtomsCoreDistWebControlsAtomToggleButtonBar.AtomToggleButtonBar;
    }, function (_webAtomsDateTimeDistTimeSpan) {
      TimeSpan = _webAtomsDateTimeDistTimeSpan.default;
    }, function (_AtomTimeFieldStyle) {
      AtomTimeFieldStyle = _AtomTimeFieldStyle.default;
    }],
    execute: function () {
      zones = [{
        label: "AM",
        value: "AM"
      }, {
        label: "PM",
        value: "PM"
      }];
      _export("default", AtomTimeField = class AtomTimeField extends AtomControl {
        preCreate() {
          super.preCreate();
          this.defaultControlStyle = AtomTimeFieldStyle;
          this.registerDisposable(new PropertyBinding(this, this.element, "time", [["this", "ts"]], true, {
            fromSource: v => toTimeString(v),
            fromTarget: v => fromTimeString(v, this.ts)
          }, this));
        }
        create() {
          this.render(XNode.create("div", {
            class: this.controlStyle.name,
            time: Bind.oneWay(() => this.changed(this.ts.hour, this.ts.minutes, this.ts.zone))
          }, XNode.create("input", {
            class: "hour",
            type: "number",
            max: "12",
            min: "0",
            value: Bind.twoWaysImmediate(() => this.ts.hour)
          }), XNode.create("input", {
            class: "minutes",
            type: "number",
            min: "0",
            max: "59",
            value: Bind.twoWaysImmediate(() => this.ts.minutes)
          }), XNode.create(AtomToggleButtonBar, {
            items: zones,
            value: Bind.twoWays(() => this.ts.zone)
          })));
        }
        changed(hour, minutes, zone) {
          const n = {
            hour,
            minutes,
            zone
          };
          return toTimeString(n);
        }
      });
      __decorate([BindableProperty, __metadata("design:type", String)], AtomTimeField.prototype, "time", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], AtomTimeField.prototype, "hour", void 0);
      __decorate([BindableProperty, __metadata("design:type", Number)], AtomTimeField.prototype, "minutes", void 0);
      __decorate([BindableProperty, __metadata("design:type", String)], AtomTimeField.prototype, "zone", void 0);
      __decorate([BindableProperty, __metadata("design:type", Object)], AtomTimeField.prototype, "ts", void 0);
    }
  };
});
//# sourceMappingURL=AtomTimeField.js.map